\name{BlockEdgeProto-class}
\docType{class}
\alias{BlockEdgeProto-class}
\alias{nodeTypesOfEdge,BlockEdgeProto-method}
\alias{oriented<-,BlockEdgeProto-method}
\alias{oriented,BlockEdgeProto-method}

\title{Class "BlockEdgeProto" }
\description{  The class for edges between blocks and for edges between vertices and blocks. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("BlockEdgeProto", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{oriented}:}{Object of class \code{"logical"}, see \code{"VertexEdgeProto"}. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{width}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
  }
}
\section{Extends}{
Class \code{"EdgeProto"}, directly.
Class \code{"NodeProto"}, by class \code{"EdgeProto"}.
}
\section{Methods}{
  \describe{
    \item{nodeTypesOfEdge}{\code{signature(object = "BlockEdgeProto")}:
       Extract the types ("super classes": \code{"Vertex"} or \code{"Block"})
       of the vertices (nodes) of the edge. }
    \item{oriented<-}{\code{signature(x = "BlockEdgeProto")}: ... }
    \item{oriented}{\code{signature(object = "BlockEdgeProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newBlockEdge}},
\code{\link{returnBlockEdgeList}},
\code{\link{EdgeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{BlockProto-class}
\docType{class}
\alias{BlockProto-class}
\alias{ancestors<-,BlockProto-method}
\alias{ancestors,BlockProto-method}
\alias{closed<-,BlockProto-method}
\alias{closed,BlockProto-method}
\alias{descendants<-,BlockProto-method}
\alias{descendants,BlockProto-method}
\alias{draw,BlockProto-method}
\alias{index<-,BlockProto-method}
\alias{index,BlockProto-method}
\alias{name,BlockProto-method}
\alias{position<-,BlockProto-method}
\alias{position,BlockProto-method}
\alias{stratum<-,BlockProto-method}
\alias{stratum,BlockProto-method}
\alias{visible<-,BlockProto-method}
\alias{visible,BlockProto-method}

\title{Class "BlockProto" }
\description{  The class for blocks. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("BlockProto", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{stratum}:}{Object of class \code{"numeric"},
       the \code{stratum} of the block. }
    \item{\code{index}:}{Object of class \code{"numeric"} 
       with (minus) the \code{index} of the block,
       the position of the block in a block list. }
    \item{\code{ancestors}:}{Object of class \code{"numeric"}.
       Integer vector for the \code{ancestor} blocks of the block. }
    \item{\code{descendants}:}{Object of class \code{"numeric"}.
       Integer vector for the \code{descendants} blocks of the block. 
       The slot with the \code{descendant} blocks is set after the creation of the block. }
    \item{\code{position}:}{Object of class \code{"matrix"},
       the \code{position} of the block, the two diagonal opposite corners. }
    \item{\code{closed}:}{Object of class \code{"logical"},
       if TRUE then the block is closed, e.i. drawn as a "vertex". }
    \item{\code{visible}:}{Object of class \code{"logical"},
       if TRUE then the block is drawn, else it is hidden in a closed block. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"NodeProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"NodeProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"NodeProto"}. } 
  }
}
\section{Extends}{
Class \code{"NodeProto"}, directly.
}
\section{Methods}{
  \describe{
    \item{ancestors<-}{\code{signature(x = "BlockProto")}: ... }
    \item{ancestors}{\code{signature(object = "BlockProto")}: ... }
    \item{closed<-}{\code{signature(x = "BlockProto")}: ... }
    \item{closed}{\code{signature(object = "BlockProto")}: ... }
    \item{descendants<-}{\code{signature(x = "BlockProto")}: ... }
    \item{descendants}{\code{signature(object = "BlockProto")}: ... }
    \item{draw}{\code{signature(object = "BlockProto")}:
       Method for drawing the closed block. }
    \item{index<-}{\code{signature(x = "BlockProto")}: ... }
    \item{index}{\code{signature(object = "BlockProto")}: ... }
    \item{name}{\code{signature(object = "BlockProto")}: 
       Extract the label of the block. }
    \item{position<-}{\code{signature(x = "BlockProto")}: ... }
    \item{position}{\code{signature(object = "BlockProto")}: ... }
    \item{stratum<-}{\code{signature(x = "BlockProto")}: ... }
    \item{stratum}{\code{signature(object = "BlockProto")}: ... }
    \item{visible<-}{\code{signature(x = "BlockProto")}: ... }
    \item{visible}{\code{signature(object = "BlockProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newBlock}},
\code{\link{setBlocks}},
\code{\link{setTreeBlocks}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{CanvasProto-class}
\docType{class}
\alias{CanvasProto-class}

\title{Class "CanvasProto" }
\description{  The class for objects unique to each dynamic graph. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("CanvasProto", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{top}:}{Object of class \code{"tkwin"}:
       The \code{tkwin}-top of the graph window. }
    \item{\code{canvas}:}{Object of class \code{"tkwin"}:
       The \code{canvas}-top of the graph window. }
    \item{\code{tags}:}{Object of class \code{"list"}:
       The tags of the objects drawn in the graph window. }
    \item{\code{id}:}{Object of class \code{"numeric"}:
       Integer, increased for each redraw of the graph window. }
    \item{\code{visibleVertices}:}{Object of class \code{"numeric"}:
       Numeric vector of the indices of the vertices of
       \code{vertexList} plotted in the graph window. }
    \item{\code{extraVertices}:}{Object of class \code{"list"}:
       The \code{extraList} of the graph in the window. }
    \item{\code{graphEdges}:}{Object of class \code{"list"}:
       The \code{edgeList} of the graph in the window. }
    \item{\code{blockEdges}:}{Object of class \code{"list"}:
       The \code{blockEdgeList} of the graph in the window. }
    \item{\code{factorVertices}:}{Object of class \code{"list"}:
       The \code{factorVertexList} of the graph in the window. }
    \item{\code{factorEdges}:}{Object of class \code{"list"}:
       The \code{factorEdgeList} of the graph in the window. }
  }
}
\section{Methods}{
No methods defined with class "CanvasProto" in the signature.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{dynamicGraphMain}},
\code{\link{GraphLatticeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{ContinuousVertexProto-class}
\docType{class}
\alias{ContinuousVertexProto-class}
\alias{draw,ContinuousVertexProto-method}

\title{Class "ContinuousVertexProto" }
\description{  The class for vertices for continuous variables. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("ContinuousVertexProto", ...)}.
Objects has the methods for extracting and setting the slots for vertices,
and the method for drawing the vertex.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"VertexProto"}, directly.
Class \code{"NodeProto"}, by class \code{"VertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "ContinuousVertexProto")}: Method for drawing the vertex.
    The symbol will be a \code{'c'circle} for \code{'c'ontinuous} variable. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertex}},
\code{\link{returnVertexList}},
\code{\link{VertexProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{DiscreteGeneratorProto-class}
\docType{class}
\alias{DiscreteGeneratorProto-class}
\alias{draw,DiscreteGeneratorProto-method}

\title{Class "DiscreteGeneratorProto" }
\description{  The class for factor vertices for discrete terms. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("DiscreteGeneratorProto", ...)}.
}
\section{Slots}{
  \describe{
%    \item{\code{test.position}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}. 
       Default is \code{cyan}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"FactorVertexProto"}, directly.
Class \code{"VertexProto"}, by class \code{"FactorVertexProto"}.
Class \code{"NodeProto"}, by class \code{"FactorVertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "DiscreteGeneratorProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactor}},
\code{\link{returnFactorVerticesAndEdges}},
\code{\link{FactorVertexProto-class}},
\code{\link{VertexProto-class}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{DiscreteVertexProto-class}
\docType{class}
\alias{DiscreteVertexProto-class}
\alias{draw,DiscreteVertexProto-method}

\title{Class "DiscreteVertexProto" }
\description{  The class for vertices for discrete variables. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("DiscreteVertexProto", ...)}.
Objects has the methods for extracting and setting the slots for vertices,
and the method for drawing the vertex.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"VertexProto"}, directly.
Class \code{"NodeProto"}, by class \code{"VertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "DiscreteVertexProto")}: Method for drawing the vertex.
    The symbol will be a \code{'d'ot} for \code{'d'iscrete} variable. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertex}},
\code{\link{returnVertexList}},
\code{\link{VertexProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{DynamicGraph}
\alias{DynamicGraph}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Simple interface to dynamicGraph}
\description{
    A simple interface to \code{dynamicGraph} in the
    sense that the graph should not be given as list of objects
    as to \code{\link{dynamicGraphMain}}. Here vertices can be 
    specified by a vector of text strings with names,
    and/or edges by pairs of the indices of the vertices.
}
\usage{
DynamicGraph(names = NULL, types = NULL, 
             from = NULL, to = NULL, edge.list = NULL,
             blocks = NULL, block.tree = NULL, oriented = FALSE,
             factors = NULL, texts = NULL, object = NULL,
             vertexClasses = validVertexClasses(),
             factorClasses = validFactorClasses(), N = 3,
             drawblocks = TRUE, right.to.left = FALSE,
             nested.blocks = FALSE, overlaying = TRUE,
             vertexColor = "red", extraVertexColor = "white",
             edgeColor = "black", factorVertexColor = "default",
             factorEdgeColor = "brown", blockEdgeColor = "default",
             blockColors = NULL, ...)
}
\arguments{
  \item{names}{ A vector with text strings for the \code{names} 
        of the vertices. }
  \item{types}{ A vector with text strings for the \code{types},
        labels of \code{\link{VertexProto}}, of the vertices. }
  \item{from}{ If not \code{edge.list} is given:
        The indices of the first endpoints of the edges. }
  \item{to}{ If not \code{edge.list} is given:
        The indices of the second endpoints of the edges. }
  \item{edge.list}{ If not \code{from} and \code{to} are given:
        A list where each item specifies an edge by a vector
        of the indices or names of the vertices. }
  \item{blocks}{ 
        A list defining the \code{blocks}:
        Each item is the vector of the indices of the vertices of the
	block, or the vector with text strings for the names of the vertices
	of the block. 
        The arguments \code{right.to.left}, \code{nested.blocks} 
        and \code{blockColors} are here used in \code{\link{setBlocks}}
        to control the layout of the blocks.
    }
  \item{block.tree}{ If not the argument \code{blocks} is used:
	A structure with the blocks in a \code{block.tree}.
        The arguments \code{overlaying} and \code{blockColors} are here used
        in \code{\link{setTreeBlocks}} to control the layout of the blocks.
        }
  \item{oriented}{ Logical. If \code{oriented} is set to TRUE
        then the edges are oriented, also when no block structure is given. }
  \item{factors}{A list defining the \code{factor vertices}:
        Each item is the vector of the indices of the vertices of a factor.
        }
  \item{texts}{ A vector of text strings, for additional labels. }
  \item{object}{ The model \code{object}, or NULL,
        see \code{\link{newDefaultModelObject}}. }
  \item{vertexClasses}{ The valid \code{vertexClasses}. }
  \item{factorClasses}{ The valid \code{factorClasses}. }
  \item{N}{ The number, \code{N} > 1, of coordinates for the positions of the
        vertices and block corners. }
  \item{drawblocks}{ Logical. If \code{drawblocks} is set to FALSE,
        then the blocks are not drawn. The strata of the vertices are
        then not updated when the vertices are moved. }
  \item{right.to.left}{ Logical. If \code{right.to.left} is set to TRUE
        then the explanatory blocks are drawn to the right.
        See \code{\link{setBlocks}}. }
  \item{nested.blocks}{ Logical. If \code{nested.blocks} is set to TRUE
        then the blocks are drawn nested. See \code{\link{setBlocks}}. }
  \item{overlaying}{ Logical. If \code{overlaying} is set to FALSE
        then childern of a block are not drawn inside the block.
        See \code{\link{setTreeBlocks}}. }
  \item{vertexColor}{ Single text string with the \code{vertexColor}
        of the vertices. }
  \item{extraVertexColor}{ Single text string with the \code{extraVertexColor}
        of the nodes for text labels. }
  \item{edgeColor}{ Single text string with the \code{edgeColor}
        of the edges. }
  \item{factorVertexColor}{ Single text string with the
        \code{factorVertexColor} of the factor vertices. 
        If \code{factorVertexColor} is "default" then
        the color of a factor vertex will depend on the
        type of the generator of the factor.}
  \item{factorEdgeColor}{ Single text string with the \code{factorEdgeColor}
        of the factor edges. }
  \item{blockEdgeColor}{ "default", or list with two text strings for colors.
        % \code{blockEdgeColor} is similar to \code{edgeColor}.
        The two colors are used for respectively edges
        between blocks and for edges between blocks 
        and vertices.}
  \item{blockColors}{ Vector of text string with the \code{blockColors}
        of the blocks.
        See \code{\link{setBlocks}} and \code{\link{setTreeBlocks}}.  }
  \item{\dots}{ Additional arguments to \code{\link{dynamicGraphMain}}. }
}
\details{
    After converting the first arguments to lists of objects
    the \code{\link{dynamicGraphMain}} does all the work.
    You can look into the source code of \code{\link{DynamicGraph}} about
    how to create these lists of objects for building your applications.
    The list of objects can be exported from
    \code{\link{dynamicGraphMain}}, also after modifying the graph.
}
\value{
  The returned value from \code{\link{dynamicGraphMain}}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{

require(tcltk)
require(dynamicGraph)

# Example 1:

Z <- DynamicGraph(paste("", 1:5), title = "Very simple")


# Example 2:

Z <- DynamicGraph(from = 1:4, to = c(2:4, 1), title = "Simply edges")


# Example 3:

V.Types <- c("Discrete", "Ordinal", "Discrete",
             "Continuous", "Discrete", "Continuous")

V.Names <- c("Sex", "Age", "Eye", "FEV", "Hair", "Shosize")
V.Names <- paste(V.Names, 1:6, sep ="/")

From <- c(1, 2, 3, 4, 5, 6)
To   <- c(2, 3, 4, 5, 6, 1)

Z <- DynamicGraph(V.Names, V.Types, From, To, texts = c("Gryf", "Gaf"),
                  title = "With labels")


# Example 4: Oriented (cyclic) edges, without causal structure:

Z <- DynamicGraph(V.Names, V.Types, From, To, oriented = TRUE,
                  title = "Oriented edges")


# Example 5: A factor graph:

Factors <- list(c(1, 2, 3, 4), c(3, 4, 5), c(4, 5, 6))

Z <- DynamicGraph(V.Names, V.Types, from = NULL, to = NULL, factors = Factors,
                  title = "Factorgraph", namesOnEdges = FALSE)


# Example 6: Edges with more than two vertices:

EdgeList <- list(c(1, 2, 3, 4), c(3, 4, 5), c(4, 5, 6))

Z <- DynamicGraph(V.Names, V.Types, edge.list = EdgeList, 
                  title = "Multiple edges", namesOnEdges = FALSE)

}
\keyword{ dplot }
\keyword{ hplot }
\keyword{ iplot }
\keyword{ dynamic }
\keyword{ graphs }
\keyword{ methods }
\keyword{ multivariate }

\eof
\name{EdgeProto-class}
\docType{class}
\alias{EdgeProto-class}
\alias{draw,EdgeProto-method}
% \alias{edgeLabel<-,EdgeProto-method}
% \alias{edgeLabel,EdgeProto-method}
% \alias{edgeWidth<-,EdgeProto-method}
% \alias{edgeWidth,EdgeProto-method}
% \alias{labelOfEdge<-,EdgeProto-method}
% \alias{labelOfEdge,EdgeProto-method}
\alias{name,EdgeProto-method}
\alias{nodeIndicesOfEdge<-,EdgeProto-method}
\alias{nodeIndicesOfEdge,EdgeProto-method}
% \alias{vertexIndices<-,EdgeProto-method}
% \alias{vertexIndices,EdgeProto-method}
\alias{label<-,EdgeProto-method}
\alias{label,EdgeProto-method}
\alias{width<-,EdgeProto-method}
\alias{width,EdgeProto-method}
% \alias{widthOfEdge<-,EdgeProto-method}
% \alias{widthOfEdge,EdgeProto-method}

\title{Class "EdgeProto" }
\description{  A skeleton class for the classes of edges. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("EdgeProto", ...)}.
Objects has the methods for extracting and setting the slots for edges,
and the method for drawing the edge.
}
\section{Slots}{
  \describe{
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}:
       The \code{vertex.indices} of the vertices of the edge. }
    \item{\code{width}:}{Object of class \code{"numeric"}:
       The \code{width} of the edge. }
    \item{\code{color}:}{Object of class \code{"character"}:
       The \code{color} of the edge. }
    \item{\code{label}:}{Object of class \code{"character"}:
       The \code{label} of the edge. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}:
       The \code{label.position} of the edge. }
  }
}
\section{Extends}{
Class \code{"NodeProto"}, directly.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "EdgeProto")}: ... }
    % \item{edgeLabel<-}{\code{signature(x = "EdgeProto")}:    
    %    Will be removed.  Same as \code{labelOfEdge<-}. }
    % \item{edgeLabel}{\code{signature(object = "EdgeProto")}: 
    %    Will be removed.  Same as \code{labelOfEdge}.   }
    % \item{edgeWidth<-}{\code{signature(x = "EdgeProto")}:    
    %    Will be removed.  Same as \code{widthOfEdge<-}. }
    % \item{edgeWidth}{\code{signature(object = "EdgeProto")}: 
    %    Will be removed.  Same as \code{widthOfEdge}.   }

    \item{label<-}{\code{signature(x = "EdgeProto")}:
       Set the \code{label} of the edge. }
    \item{label}{\code{signature(object = "EdgeProto")}:
       Return the \code{label} of the edge. }
    % \item{labelOfEdge<-}{\code{signature(x = "EdgeProto")}: 
    %    Will be removed.  Same as the method \code{label<-}. 
    %    Set the \code{label} of the edge. }
    % \item{labelOfEdge}{\code{signature(object = "EdgeProto")}: 
    %    Will be removed.  Same as the method \code{label}. 
    %    Return the \code{label} of the edge. }

    \item{name}{\code{signature(object = "EdgeProto")}: 
       Return the \code{name}, equal to the \code{label}, of the edge. }
    \item{nodeIndicesOfEdge<-}{\code{signature(x = "EdgeProto")}:
       Set the \code{indices} of the vertices of the edge. }
    \item{nodeIndicesOfEdge}{\code{signature(object = "EdgeProto")}:
       Return the \code{indices} of the vertices of the edge. }
%     \item{vertexIndices<-}{\code{signature(x = "EdgeProto")}: ... }
%     \item{vertexIndices}{\code{signature(object = "EdgeProto")}: ... }

    \item{width<-}{\code{signature(x = "EdgeProto")}:
       Set the \code{width} of the edge. }
    \item{width}{\code{signature(object = "EdgeProto")}:
       Return the \code{width} of the edge. }
    % \item{widthOfEdge<-}{\code{signature(x = "EdgeProto")}: 
    %    Will be removed.  Same as the method \code{width<-}. 
    %    Set the \code{width} of the edge. }
    % \item{widthOfEdge}{\code{signature(object = "EdgeProto")}: 
    %    Will be removed.  Same as the method \code{width}. 
    %    Return the \code{width} of the edge. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{VertexEdgeProto-class}},
\code{\link{BlockEdgeProto-class}},
\code{\link{FactorEdgeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{FactorEdgeProto-class}
\docType{class}
\alias{FactorEdgeProto-class}
\alias{nodeTypesOfEdge,FactorEdgeProto-method}

\title{Class "FactorEdgeProto" }
\description{  The class for the bipartite graph edges between vertices and factors. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("FactorEdgeProto", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{width}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
  }
}
\section{Extends}{
Class \code{"EdgeProto"}, directly.
Class \code{"NodeProto"}, by class \code{"EdgeProto"}.
}
\section{Methods}{
  \describe{
    \item{nodeTypesOfEdge}{\code{signature(object = "FactorEdgeProto")}:
      Extract the types ("super classes": \code{"Vertex"} or \code{"Factor"})
      of the vertices (nodes) of the edge. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactorEdge}},
\code{\link{returnFactorEdgeList}},
\code{\link{EdgeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{FactorVertexProto-class}
\docType{class}
\alias{FactorVertexProto-class}
\alias{nodeIndices<-,FactorVertexProto-method}
\alias{nodeIndices,FactorVertexProto-method}
\alias{index<-,FactorVertexProto-method}
\alias{index,FactorVertexProto-method}

\title{Class "FactorVertexProto" }
\description{  A skeleton class for the classes of factor vertices. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("FactorVertexProto", ...)}.
}
\section{Slots}{
  \describe{
%    \item{\code{test.position}:}{Object of class \code{"numeric"}:
%       The \code{position} of a test statistic for the factor. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}:
       The \code{vertex.indices} of the vertices of the factor. }
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"VertexProto"}, directly.
Class \code{"NodeProto"}, by class \code{"VertexProto"}.
}
\section{Methods}{
  \describe{
    \item{nodeIndices<-}{\code{signature(x = "FactorVertexProto")}: ... }
    \item{nodeIndices}{\code{signature(object = "FactorVertexProto")}: ... }
    \item{index<-}{\code{signature(x = "FactorVertexProto")}: ... }
    \item{index}{\code{signature(object = "FactorVertexProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactor}},
\code{\link{returnFactorVerticesAndEdges}},
\code{\link{VertexProto-class}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{GeneratorProto-class}
\docType{class}
\alias{GeneratorProto-class}
\alias{draw,GeneratorProto-method}

\title{Class "GeneratorProto" }
\description{  The class for factor vertices for general terms. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("GeneratorProto", ...)}.
}
\section{Slots}{
  \describe{
%    \item{\code{test.position}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}.
       Default is \code{yellow}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"FactorVertexProto"}, directly.
Class \code{"VertexProto"}, by class \code{"FactorVertexProto"}.
Class \code{"NodeProto"}, by class \code{"FactorVertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "GeneratorProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactor}},
\code{\link{returnFactorVerticesAndEdges}},
\code{\link{FactorVertexProto-class}},
\code{\link{VertexProto-class}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{GraphLatticeProto-class}
\docType{class}
\alias{GraphLatticeProto-class}

\title{Class "GraphLatticeProto" }
\description{  The class for dynamic graph lattice. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("GraphLatticeProto", ...)}.
The object is the returned value from \code{\link{dynamicGraphMain}}.
}
\section{Slots}{
  \describe{
    \item{\code{vertices}:}{Object of class \code{"list"}:
        The \code{vertexList} of the graph window. }
    \item{\code{blocks}:}{Object of class \code{"list"}:
        The \code{blockList} of the graph window. }
    \item{\code{blockTree}:}{Object of class \code{"list"}:
        The \code{blockTree} of the graph window. }
    \item{\code{graphs}:}{Object of class \code{"list"}:
        A list of objects, each of class \code{\link{CanvasProto-class}}. }
  }
}
\section{Methods}{
No methods defined with class "GraphLatticeProto" in the signature.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{dynamicGraphMain}},
\code{\link{CanvasProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{LinearGeneratorProto-class}
\docType{class}
\alias{LinearGeneratorProto-class}
\alias{draw,LinearGeneratorProto-method}

\title{Class "LinearGeneratorProto" }
\description{  The class for factor vertices for linear terms. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("LinearGeneratorProto", ...)}.
}
\section{Slots}{
  \describe{
%    \item{\code{test.position}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}.
       Default is \code{magenta}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"FactorVertexProto"}, directly.
Class \code{"VertexProto"}, by class \code{"FactorVertexProto"}.
Class \code{"NodeProto"}, by class \code{"FactorVertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "LinearGeneratorProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactor}},
\code{\link{returnFactorVerticesAndEdges}},
\code{\link{FactorVertexProto-class}},
\code{\link{VertexProto-class}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{NodeProto-class}
\docType{class}
\alias{NodeProto-class}
\alias{addToPopups,NodeProto-method}
\alias{color<-,NodeProto-method}
\alias{color,NodeProto-method}
\alias{label<-,NodeProto-method}
\alias{label,NodeProto-method}
\alias{labelPosition<-,NodeProto-method}
\alias{labelPosition,NodeProto-method}

\title{Class "NodeProto" }
\description{  A skeleton class for the classes of vertices, edges and block objects. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("NodeProto", ...)}.
The objects has the slots and methods relevant to vertices, edges and blocks.
}
\section{Slots}{
  \describe{
    \item{\code{color}:}{Object of class \code{"character"}
        with the \code{color} of the object. }
    \item{\code{label}:}{Object of class \code{"character"}
        with the \code{label} of the object. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}
        with the \code{label.positions} of the object. }
  }
}
\section{Methods}{
  \describe{
    \item{addToPopups}{\code{signature(object = "NodeProto")}: 
        Add items to the pop up menu (\code{nodePopupMenu}) of the object
        by \code{tkadd}.
    }
    \item{color<-}{\code{signature(x = "NodeProto")}:
        Set the \code{color} of the object. }
    \item{color}{\code{signature(object = "NodeProto")}:
        Return the \code{color} of the object. }
    \item{label<-}{\code{signature(x = "NodeProto")}:
        Set the \code{label} of the object. }
    \item{label}{\code{signature(object = "NodeProto")}:
        Return the \code{label} of the object. }
    \item{labelPosition<-}{\code{signature(x = "NodeProto")}:
        Set the \code{label.position} of the object. }
    \item{labelPosition}{\code{signature(object = "NodeProto")}:
        Return the \code{label.position} of the object. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{VertexProto-class}},
\code{\link{EdgeProto-class}},
\code{\link{BlockProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{OrdinalVertexProto-class}
\docType{class}
\alias{OrdinalVertexProto-class}
\alias{draw,OrdinalVertexProto-method}

\title{Class "OrdinalVertexProto" }
\description{  The class for vertices for ordinal variables. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("OrdinalVertexProto", ...)}.
Objects has the methods for extracting and setting the slots for vertices,
and the method for drawing the vertex.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"VertexProto"}, directly.
Class \code{"NodeProto"}, by class \code{"VertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "OrdinalVertexProto")}: Method for drawing the vertex.
    The symbol will be a \code{filled square} for \code{ordinal} variable. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertex}},
\code{\link{returnVertexList}},
\code{\link{VertexProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{QuadraticGeneratorProto-class}
\docType{class}
\alias{QuadraticGeneratorProto-class}
\alias{draw,QuadraticGeneratorProto-method}

\title{Class "QuadraticGeneratorProto" }
\description{  The class for factor vertices for quadratic terms. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("QuadraticGeneratorProto", ...)}.
}
\section{Slots}{
  \describe{
%    \item{\code{test.position}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"FactorVertexProto"}. }
    \item{\code{name}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{index}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{stratum}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"VertexProto"}.
       Default is \code{blue}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"VertexProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"VertexProto"}. }
  }
}
\section{Extends}{
Class \code{"FactorVertexProto"}, directly.
Class \code{"VertexProto"}, by class \code{"FactorVertexProto"}.
Class \code{"NodeProto"}, by class \code{"FactorVertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "QuadraticGeneratorProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newFactor}},
\code{\link{returnFactorVerticesAndEdges}},
\code{\link{FactorVertexProto-class}},
\code{\link{VertexProto-class}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{TextVertexProto-class}
\docType{class}
\alias{TextVertexProto-class}
\alias{draw,TextVertexProto-method}

\title{Class "TextVertexProto" ~~~ }
\description{  The class for vertices for setting text string in the graph window. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("TextVertexProto", ...)}.
The vertices of nodes of this class are drawn with very small symbols.
Objects has the methods for extracting and setting the slots for vertices.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"} 
       with the \code{name} of the vertex. }
    \item{\code{index}:}{Object of class \code{"numeric"} 
       with the \code{index} of the vertex,
       the position of the vertex in the extra list. }
    \item{\code{position}:}{Object of class \code{"numeric"} 
       with the \code{position} of the vertex.
       Vertices in the same dynamic graph should
       have the same number of coordinates. 
       A small dot is placed at the position of the vertex. 
       This dot can be move outside the window. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}
       with the \code{blockindex} of the vertex. }
    \item{\code{stratum}:}{Object of class \code{"numeric"} 
       with the \code{stratum} of the vertex. }
    \item{\code{color}:}{Object of class \code{"character"}
       with the \code{color} of the vertex. }
    \item{\code{label}:}{Object of class \code{"character"}
       with the \code{label} of the vertex. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}
       with the \code{label.position} of the vertex.
       Labels of vertices in the same dynamic graph
       should have the same number of coordinates. }
  }
}
\section{Extends}{
Class \code{"VertexProto"}, directly.
Class \code{"NodeProto"}, by class \code{"VertexProto"}.
}
\section{Methods}{
  \describe{
    \item{draw}{\code{signature(object = "TextVertexProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertex}},
\code{\link{returnVertexList}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{VertexEdgeProto-class}
\docType{class}
\alias{VertexEdgeProto-class}
\alias{nodeTypesOfEdge,VertexEdgeProto-method}
\alias{oriented<-,VertexEdgeProto-method}
\alias{oriented,VertexEdgeProto-method}

\title{Class "VertexEdgeProto" }
\description{  The class for edges between vertices. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("VertexEdgeProto", ...)}.
Objects has the methods for extracting and setting the slots for edges,
and the method for drawing the edge.
}
\section{Slots}{
  \describe{
    \item{\code{oriented}:}{Object of class \code{"logical"}.
       If TRUE, then the edge is \code{oriented},
       and thus drawn by an \code{arrow}, also when no blocks are pressent. }
    \item{\code{vertex.indices}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{width}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
    \item{\code{color}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label}:}{Object of class \code{"character"}, see \code{"EdgeProto"}. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}, see \code{"EdgeProto"}. }
  }
}
\section{Extends}{
Class \code{"EdgeProto"}, directly.
Class \code{"NodeProto"}, by class \code{"EdgeProto"}.
}
\section{Methods}{
  \describe{
    \item{nodeTypesOfEdge}{\code{signature(object = "VertexEdgeProto")}: ... }
    \item{oriented<-}{\code{signature(x = "VertexEdgeProto")}: ... }
    \item{oriented}{\code{signature(object = "VertexEdgeProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertexEdge}},
\code{\link{returnEdgeList}},
\code{\link{EdgeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{VertexProto-class}
\docType{class}
\alias{VertexProto-class}
\alias{ancestors<-,VertexProto-method}
\alias{ancestors,VertexProto-method}
\alias{blockindex<-,VertexProto-method}
\alias{blockindex,VertexProto-method}
\alias{descendants<-,VertexProto-method}
\alias{descendants,VertexProto-method}
\alias{index<-,VertexProto-method}
\alias{index,VertexProto-method}
\alias{name<-,VertexProto-method}
\alias{name,VertexProto-method}
\alias{position<-,VertexProto-method}
\alias{position,VertexProto-method}
\alias{stratum<-,VertexProto-method}
\alias{stratum,VertexProto-method}
% \alias{vertexIndices<-,VertexProto-method}
% \alias{vertexIndices,VertexProto-method}
\alias{visible<-,VertexProto-method}
\alias{visible,VertexProto-method}

\title{Class "VertexProto" }
\description{  A skeleton class for the classes of vertices. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("VertexProto", ...)}.
Objects has the methods for extracting and setting the slots for vertices.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"} 
       with the \code{name} of the vertex. 
       Should be a valid name on variables for your model object.}
    \item{\code{index}:}{Object of class \code{"numeric"} 
       with the \code{index} of the vertex,
       the position of the vertex in a vertex list. }
    \item{\code{position}:}{Object of class \code{"numeric"} 
       with the \code{position} of the vertex.
       Vertices in the same dynamic graph should
       have the same number of coordinates. }
    \item{\code{blockindex}:}{Object of class \code{"numeric"}
       with the \code{blockindex} of the vertex. }
    \item{\code{stratum}:}{Object of class \code{"numeric"} 
       with the \code{stratum} of the vertex. }
    \item{\code{color}:}{Object of class \code{"character"}
       with the \code{color} of the vertex. }
    \item{\code{label}:}{Object of class \code{"character"}
       with the \code{label} of the vertex. }
    \item{\code{label.position}:}{Object of class \code{"numeric"}
       with the \code{label.position} of the vertex.
       Labels of vertices in the same dynamic graph
       should have the same number of coordinates. }
  }
}
\section{Extends}{
Class \code{"NodeProto"}, directly.
}
\section{Methods}{
  \describe{
    \item{ancestors<-}{\code{signature(x = "VertexProto")}: ... }
    \item{ancestors}{\code{signature(object = "VertexProto")}: ... }
    \item{blockindex<-}{\code{signature(x = "VertexProto")}: ... }
    \item{blockindex}{\code{signature(object = "VertexProto")}: ... }
    \item{descendants<-}{\code{signature(x = "VertexProto")}: ... }
    \item{descendants}{\code{signature(object = "VertexProto")}: ... }
    \item{index<-}{\code{signature(x = "VertexProto")}: ... }
    \item{index}{\code{signature(object = "VertexProto")}: ... }
    \item{name<-}{\code{signature(x = "VertexProto")}: ... }
    \item{name}{\code{signature(object = "VertexProto")}: ... }
    \item{position<-}{\code{signature(x = "VertexProto")}: ... }
    \item{position}{\code{signature(object = "VertexProto")}: ... }
    \item{stratum<-}{\code{signature(x = "VertexProto")}: ... }
    \item{stratum}{\code{signature(object = "VertexProto")}: ... }
%     \item{vertexIndices<-}{\code{signature(x = "VertexProto")}: ... }
%     \item{vertexIndices}{\code{signature(object = "VertexProto")}: ... }
    \item{visible<-}{\code{signature(x = "VertexProto")}: ... }
    \item{visible}{\code{signature(object = "VertexProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{newVertex}},
\code{\link{returnVertexList}},
\code{\link{NodeProto-class}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{blockTreeToList}
\alias{blockTreeToList}
\title{Extract the list of blocks from a block tree}
\description{Returns the list of blocks from a block tree.}
\usage{blockTreeToList(tree)}
\arguments{
  \item{tree}{ The \code{BlockTree} part of the result of
               \code{\link{setTreeBlocks}}. }
}
%\details{}
\value{A list of blocks, each block of class \code{BlockProto}.}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% ~Make other sections like Warning with \section{Warning }{....} ~
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
Block.tree <- list(label = "W", Vertices = c("contry"),
                   X = list(Vertices = c("sex", "race"),
                            A = list(Vertices = c("hair", "eye"),
                                     horizontal = FALSE),
                            B = list(Vertices = c("age"),
                                     C = list(Vertices = c("education")))))
Names <- unlist(Block.tree)
Names <- Names[grep("Vertices", names(Names))]
Types <- rep("Discrete", length(Names))
vertices <- returnVertexList(Names, types = Types)
blocktree <- setTreeBlocks(Block.tree, vertices)
Labels(blockTreeToList(blocktree$BlockTree))
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{defaultModelObjectProto-class}
\docType{class}
\alias{defaultModelObjectProto-class}
\alias{modifyModel,defaultModelObjectProto-method}
\alias{testEdge,defaultModelObjectProto-method}

\title{Class "defaultModelObjectProto" }
\description{  An example class for the model object of dynamicGraph. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("defaultModelObjectProto", ...)}.

This is an example of the object for interface between
\code{\link{dynamicGraphMain}} and your models.
The model object of the call of \code{\link{dynamicGraphMain}}
should have the methods \code{modifyModel} and \code{testEdge}.
When the graph is modified, by adding or dropping vertices or edge,
the method \code{modifyModel} is called on the argument \code{object}
of \code{\link{dynamicGraphMain}}. If an \code{object} is returned in
the list of the returned value from \code{modifyModel} then
\code{object} in \code{\link{dynamicGraphMain}} is replaced by this
object, and the object is also assigned in the top level environment,
if  \code{objectName} was given to \code{\link{dynamicGraphMain}}.

The methods \code{testEdge} of \code{object} should return an object with the methods 
\code{label} and \code{width} % (was \code{labelOfTest} and \code{widthOfTest})
for labeling edges, see \code{\link{newDefaultTestObject}}.

}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"}:
      The \code{name} of the model. }
  }
}
\section{Methods}{
  \describe{
    \item{modifyModel}{\code{signature(object = "defaultModelObjectProto")}: ... }
    \item{testEdge}{\code{signature(object = "defaultModelObjectProto")}: ... }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{defaultTestObjectProto-class}},
\code{\link{newDefaultModelObject}},
\code{\link{newDefaultTestObject}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{defaultTestObjectProto-class}
\docType{class}
\alias{defaultTestObjectProto-class}
\alias{label,defaultTestObjectProto-method}
\alias{width,defaultTestObjectProto-method}
% \alias{labelOfTest,defaultTestObjectProto-method}
% \alias{widthOfTest,defaultTestObjectProto-method}
% \alias{testLabel,defaultTestObjectProto-method}
% \alias{testWidth,defaultTestObjectProto-method}

\title{Class "defaultTestObjectProto" }
\description{  An example class for the test object for the model object of dynamicGraph. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("defaultTestObjectProto", ...)}.

    The methods 
    \code{label} and \code{width} % (was \code{labelOfTest} and \code{widthOfTest})
    should be implemented by you for your test object returned by the method
    \code{testEdge} of your model \code{object}. 
}
\section{Slots}{
  \describe{
    \item{\code{deviance}:}{Object of class \code{"numeric"}: 
        The \code{deviance} of the test. }
    \item{\code{df}:}{Object of class \code{"numeric"}: 
        The \code{df} of the test. }
    \item{\code{p}:}{Object of class \code{"numeric"}: 
        The \code{p}-value of the test. }
  }
}
\section{Methods}{
  \describe{
    \item{label}{\code{signature(object = "defaultTestObjectProto")}: 
       Return the \code{label} of the test. }
    \item{width}{\code{signature(object = "defaultTestObjectProto")}:
       Return the \code{width} of the test. }
%     \item{labelOfTest}{\code{signature(object = "defaultTestObjectProto")}: 
%        Will be removed.  Same as the method \code{label}. 
%        Return the \code{label} of the test. }
%     \item{widthOfTest}{\code{signature(object = "defaultTestObjectProto")}: 
%        Will be removed.  Same as the method \code{width}. 
%        Return the \code{width} of the test. }
%     \item{testLabel}{\code{signature(object = "defaultTestObjectProto")}: 
%        Will be removed.  Same as \code{labelOfTest}. }
%     \item{testWidth}{\code{signature(object = "defaultTestObjectProto")}: 
%        Will be removed.  Same as \code{labelOfTest}. }
  }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{
\code{\link{defaultModelObjectProto-class}},
\code{\link{newDefaultModelObject}},
\code{\link{newDefaultTestObject}}.
}
% \examples{ }
\keyword{classes}

\eof
\name{dynamicGraph-internal}
\title{Internal dynamicGraph objects}
\alias{.First.lib}
\alias{.onLoad}
\alias{.onLoad.dynamicGraph}
\alias{.onLoad.dynamicGraphInterface}
\description{Internal dynamicGraph objects.}
\details{These are not to be called by the user.}
\keyword{internal}

\eof
\name{dynamicGraphMain}
\alias{dynamicGraphMain}
\alias{dynamicGraph}
\alias{GraphLatticeProto}
\alias{CanvasProto}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Dynamic Graph }
\description{
    Interactive plot for manipulating graphs.
}
\usage{
dynamicGraphMain(vertexList, visibleVertices = 1:length(vertexList),
                 edgeList = NULL, blockList = NULL, blockEdgeList = NULL,
                 blockTree = NULL, oriented = FALSE,
                 factorVertexList = NULL, factorEdgeList = NULL, 
                 extraList = NULL,
                 object = NULL, objectName = "", 
                 vertexClasses = validVertexClasses(),
                 title = "dynamicGraph", transformation = NULL, 
                 width = 400, height = 400, w = 6, 
                 vertexColor = "blue", extraVertexColor = "black", 
                 edgeColor = "blue",
                 factorVertexColor = "green", factorEdgeColor = "green",
                 blockEdgeColor = "default", blockColors = NULL,
                 background = "white", closeenough = 2,
                 drawBlockFrame = TRUE, drawBlockBackground = TRUE,
                 UserMenus = NULL, 
                 hasMethods = TRUE, enterLeaveUpdate = TRUE,
                 namesOnEdges = TRUE, updateEdgeLabels = TRUE,
                 debug.strata = FALSE, debug.edges = FALSE,
                 debug.position = FALSE, debug.update = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{vertexList}{ List of vertices
        (each of class containing the class \code{VertexProto})
        created by \code{\link{returnVertexList}}
        or exported from \code{\link{dynamicGraphMain}}. }
    \item{visibleVertices}{ Numeric vector of the indices of the vertices of
        \code{vertexList} to plot. }
    \item{edgeList}{ List of edges (of class containing \code{EdgeProto})
        created by \code{\link{returnEdgeList}}
        or exported from \code{\link{dynamicGraphMain}}.  }
    \item{blockList}{ List of blocks (each of class \code{BlockProto})
        created by \code{\link{setBlocks}}
        or exported from \code{\link{dynamicGraphMain}}.
        If the \code{blockTree} argument is given, then
        the argument \code{blockList} should not also be given. }
    \item{blockEdgeList}{ List of blockedges
        (of class containing the class \code{BlockEdgeProto})
        created by \code{\link{returnBlockEdgeList}}
        or exported from \code{\link{dynamicGraphMain}}. }
    \item{blockTree}{ Structure with blocks (of class \code{BlockProto})
        created by \code{\link{setTreeBlocks}}
        or exported from \code{\link{dynamicGraphMain}}. }
    \item{oriented}{ Logical.  If TRUE then
        edges are oriented, also when blocks are missing. }
    \item{factorVertexList}{ List of secondary vertices,
        called factor vertices, for, e.g., the generators of the model,
        (each of class containing \code{FactorVertexProto})
        created by \code{\link{returnFactorVerticesAndEdges}}
        or exported from \code{\link{dynamicGraphMain}}. }
    \item{factorEdgeList}{ List of bipartite graph edges,
        called factor edges,
        (each of class containing \code{FactorEdgeProto})
        created by \code{\link{returnFactorEdgeList}}
        or exported from \code{\link{dynamicGraphMain}}.
        Factor edges are edges between vertices and factor vertices. }
    \item{extraList}{ List of vertices (of class containing the class
	\code{VertexProto}) 
        created by \code{\link{returnVertexList}}
        or exported from \code{\link{dynamicGraphMain}},
        for, e.g., additional titles in the plot. }
    \item{object}{ NULL, or object with the methods \code{\link{modifyModel}}
        and \code{\link{testEdge}} - for respectively updating the
        object when the graph is updated, and for computing the
	test statistic when an edge is labeled. The returned object from
        \code{\link{testEdge}} should have the methods 
        \code{label} and \code{width}
        % (was \code{labelOfTest} and \code{widthOfTest})
        for extracting the label of a test for putting the label on the edge
        and for extracting the width for the edge.
        See \code{\link{newDefaultModelObject}}. }
    \item{objectName}{ If set to a text string then the object is assigned with
	this name in .Global.Env when the object is updated. }
    \item{vertexClasses}{ Returned value from \code{\link{validVertexClasses}},
        or extension of this matrix. Used when creating
        new vertices in \code{\link{dynamicGraphMain}}. }
    \item{title}{ Text string with the title set on the graph window. }
    \item{transformation}{ NULL,
                or rotation matrix for projecting the positions
        of the vertices, blocks, etc. onto the canvas. }
    \item{width}{ Integer with the width of the plot canvas. }
    \item{height}{ Integer with the height of the plot canvas. }
    \item{w}{ The \code{radius} of the vertices. Send as argument to the
        \code{draw} method for vertices, and edges are shortened
        by the quantity in each end. }
    \item{vertexColor}{ Single text string. 
        Colors of new vertices created in
        \code{\link{dynamicGraphMain}}
        (by \code{\link{newVertex}}).
        The colors of the vertices of \code{vertexList} are
        given in this list. \code{vertexColor} is given as
        argument to the \code{draw} method of vertices, but this 
        argument are by default not used in the draw method. }
    \item{extraVertexColor}{ Single text string. 
        As \code{vertexColor}, but for the vertices of
        \code{extraList}. }
    \item{edgeColor}{ Single text string. 
        \code{edgeColor} is similar to \code{vertexColor}. }
    \item{factorVertexColor}{ Single text string. 
        \code{factorVertexColor} is similar to
        \code{vertexColor}.
        If \code{factorVertexColor} is "default" then
        the color of a factor vertex will depend on the
        type of the generator of the factor. }
    \item{factorEdgeColor}{ Single text string. 
        \code{factorEdgeColor}
        is similar to \code{edgeColor}. }
    \item{blockEdgeColor}{ "default", or list with two text strings for colors.
        \code{blockEdgeColor} is similar to \code{edgeColor}.
        The two colors are used for respectively edges
        between two blocks and for edges between blocks 
        and vertices. }
    \item{blockColors}{ List of colors of blocks. 
        Similar to \code{vertexColor}: Only used when creating
        new blocks, else the colors set in \code{blockList}
        and \code{blockTree} are used. }
    \item{background}{ The color of the canvas of the graph window,
        default: "white". }
    \item{closeenough}{ Parameter for whether the mouse is close enough
        when clicking an object of the graph window,
        see \code{\link[tcltk]{tkcanvas}}. }
    \item{drawBlockFrame}{ Logical.
                If TRUE then frames are drawn around blocks. }
    \item{drawBlockBackground}{ Logical. If TRUE then a \code{block canvas} is
        drawn, with color set by \code{blockColors}. }
    \item{UserMenus}{ List with user defined menu items for main menu
        and pop up menus. See \code{\link{redrawGraphWindow}}
        for an example of a user specified menu. }
    \item{hasMethods}{ Logical. 
        If TRUE then the \code{object} should have the methods
        \code{\link{modifyModel}} and \code{\link{testEdge}}. 
        (I do not know why the R-function
         \code{\link[methods]{hasMethod}} does not
        work on \code{objects} (defined outside the package
	\code{\link{dynamicGraph}})
	inside \code{\link{dynamicGraphMain}}).}
    \item{enterLeaveUpdate}{ Logical. If FALSE then the graph window
        is not redrawn when the mouse enters and leaves the graph window. }
    \item{namesOnEdges}{ Logical. If FALSE then the names of the vertices 
        are not set on the edge as label. }
    \item{updateEdgeLabels}{ Logical.  If FALSE then the edge labels
        are not cleared when the model is updated. }
    \item{debug.strata}{ Logical for tracing strata of vertices
                (also in plot). }
    \item{debug.edges}{ Logical for tracing edges (also by labels in plot). }
    \item{debug.position}{ Logical for tracing positions of vertices. }
    \item{debug.update}{ Logical for tracing redraw of graph window. }
    \item{\dots}{ Additional arguments. }
}

\details{

    This is a dynamic plotting tool for handling graphs.
    The lay out of the graph can be edited by moving
    the vertices of the graph by the mouse, and edges can be 
    added by clicking vertices and dropping by clicking the edges.

    The function is incremental in the sense that the user can add a method
    for updating the model object of the window when the graph is updated,
    and a method for computing the test of an edge when the edge is clicked
    by the mouse.
    
    Edges can be oriented, drawn by arrows.
    
    Blocks can be used to define a causal structure of the variables
    represented by vertices, and edges between blocks are then oriented.
    Blocks can be given in a structure such that descendant blocks of a blocks
    also are closed when a block is closed.
    
    A secondary set of vertices, factor vertices, can be used to represent
    hypergraphs.
    
    "Slave graph windows" can be created: The windows will share vertices
    and blocks, thus when a vertex is moved in one window, the position of
    the vertex will also change in all slave windows. The edges are not
    shared among windows, since the individual windows will typical
    represent different models.
    Thus factors (vertices and edges) are not shared between graph windows.

    }

% Rotate:            Right click and drag

% Rock plot:         Double right click (not working!)

\value{
    Object of class \code{\link{GraphLatticeProto}}.
    Might, beside the list of canvases of the graph window and slave windows,
    also hold lists of vertices and blocks (block trees).
    \item{...@graphs}{Slot 'graphs': List of class \code{\link{CanvasProto}}.
	Might, beside slots for accessing the graph window, also hold 
	slots for edges, factors, factor edges, block edges, etc.}
    \item{...@graphs[[i]]@top}{Slot 'top' of each object in the list of the
        'graphs' slot of the returned object:
        The 'top' of the canvas of the i-the 
        graph window.}
}

    \section{All object in the graph window:}{
	\itemize{
	    \item{Left click, hold and drag:}{The object will move.}
	    \item{Left click:}{Action to the object:
                Vertices and blocks will highlight, 
                at vertices and blocks edges are added after highlight,
                at edges the edge will be deleted,
                tests are computed for edge labels.}
	    \item{Double left click:}{Action to object:
                Vertices are deleted,
                blocks will close,
                closed blocks will open.}
	    \item{Right click:}{The pop up menu of the object will appear.}
        }
    }

    \section{Vertices (vertices and factor vertices):}{
	Right click the vertex to get the pop up menu of the vertex:
	\itemize{
	    \item{Highlight a vertex:}{For adding an edge - Click the vertex.}
	    \item{Cancel highlighting:}{Left click (or drag) the vertex.}
	    \item{Add an edge:}{After first highlighting a vertex - 
                Left click the other vertex.}
	    \item{Move a vertex:}{Left click and drag the vertex.}
	    \item{Move a vertex label:}{Left click and
                drag the label of the vertex.}
	    \item{Delete a vertex:}{Double left click the vertex.}
	    \item{Create new graph:}{A slave window with the vertex delete -
		Select "Drop vertex" from pop up menu at the vertex.}
	    \item{Change a vertex label:}{Double left click the label,
		and enter the new label in the appearing dialog window.}
	    \item{Delete a vertex label:}{Select "Delete vertex label" from
		the pop up menu at the vertex or at the vertex label.}
	    \item{Create new vertex:}{At mouse position -
		Middle click the canvas.}
	    \item{Create new vertex:}{At mouse position
                with the edge to last vertex -
		Double middle click the canvas.}
	}
	The main menu "Variables":
	\itemize{
	    \item{Create new variable:}{With setting the class of the new
		vertex and defining an expression for updating the
		\code{object} - Select "Create new variable".} 
	    \item{Display, add, a vertex:}{In the current window -
		Select "Select vertex among variables not displayed (here)". }
	    \item{Display, add, a vertex:}{In a slave window -
		Select "Select vertex among variables not displayed (slave)". }
	    \item{Export the vertex list:}{Select
                "Assign Vertices in .GlobalEnv". }
	    \item{Export the labels:}{Select
                "Assign ExtraVertices in .GlobalEnv". }
	}
    }
    
    \section{Edges (edges to/from vertices, blocks and factors):}{
	Right click the edge to get the pop up menu of the edge:
	\itemize{
	    \item{Add an edge:}{Left click first the vertex (or block)
                to highlight, and then left click other vertex (or block).}
	    \item{Delete an edge:}{And update in the current window -
		Left click the edge.}
	    \item{Delete an edge:}{And create a slave graph with the
		resulting graph
		- Select "Drop edge" from the pop up menu at the edge.}
	    \item{Move an edge (2 vertices):}{Left
                click the edge and drag the edge.}
	    \item{Move an edge label:}{Left click the edge label and
		drag the label.}
	    \item{Set an edge label:}{Select "Set edge label" from the
		edge pop up menu.}
	    \item{Compute an edge label:}{Left click the edge label,
		or select "Compute edge label" from pop up menu at the edge.}
	    \item{Compute an edge label:}{Force computation for
		"harder models" - Double left  click the edge label,
		or select "Force compute edge label" from pop up menu of
		the edge.}
	    \item{Delete an edge label:}{Triple left click the edge label,
		or select "Delete label of edge" from the pop up menu at
		the edge.}
	}
	The main menu "Edges":
	\itemize{
	    \item{Delete all edge labels:}{Select "Delete all edge labels". }
	    \item{Export the edge list:}{Select "Assign Edges in .GlobalEnv". }
	}
    }

    \section{Blocks, opened:}{
	Right click the block label (or colored  block canvas if
	\code{drawBlockBackground} is set to TRUE) to get the pop up
	menu of opened block:
	\itemize{
	\item{Move a block:}{With its sub blocks and vertices - 
                Left click the block label or colored block canvas and
		drag the block. [ Slow !!!] } 
	\item{Resize a block:}{Left click a block corner or a block
                edge and drag. }
	\item{Minimize a block:}{With its sub blocks and vertices - 
                Double left click the block label or the colored block canvas.
              }
	\item{Maximize a block:}{Zoom to the block - Right click the
                block label or colored the block canvas and select
		"Maximize" in the appering popup menu. }
	\item{Zoom out to the full graph:}{Right click the block label
	    or colored block canvas and select "Redraw (Zoom to) full
	    graph" in the appearing block pop up menu. }
	    }
    }			  			   	

    \section{Blocks, closed:}{
        Right click the block to get the pop up menu of the closed block:
	\itemize{
	    \item{Highlight a block:}{For adding edges from all vertices
		of the block to a vertex or a block - Click the block.}
	    \item{Cancel highlighting:}{Of a block - Left click (or drag)
		the block.}
	    \item{Add edges:}{To all vertices of block
		after highlighting first a block or a vertex - Click
                the other block.}
	    \item{Move a closed block:}{Left click and drag the block.}
	    \item{Move a block label:}{Left click and drag the label
                of the block.}
	    \item{Open a closed block:}{Double left click the block.}
	    \item{Change a block label:}{Double left click the label of
		the closed block, 
		and enter the new label in the appearing dialog window.}
	    \item{Delete a block label:}{Select "Delete label of block" from
		the pop up menu at the block or the block label.}
	}
	The main menu "Blocks":
	\itemize{	    
	    \item{Export the block list:}{Select
                "Assign BlockList in .GlobalEnv". }
	    \item{Export the block tree:}{Select
                "Assign BlockTree in .GlobalEnv". }
	    \item{Export the block edges:}{Select
                "Assign BlockEdges in .GlobalEnv". }
	}
    }			  			   	

    \section{Factor vertices:}{
        Right click the factor vertex to get the pop up menu of the
	factor: Actions as for vertices.
% 	\itemize{
% 	    \item{Pop up menu for factor vertex:}{Right click the
%                 factor vertex:
% 		Actions as for vertices.}
% 	}
	The main menu "Generators":
	\itemize{	    
	    \item{Export the factor vertices:}{Select
                "Assign FactorVertices in .GlobalEnv". }
	    \item{Export the factor edges:}{Select
                "Assign FactorEdges in .GlobalEnv". }
		}			  			   	
	    }  			   	
	    
    \section{Factor edges:}{
        Right click the factor edge to get the pop up menu of the factor
	edge: Actions are as for edges.
%	\itemize{
%	    \item{Pop up menu for factor edges:}{Right click the factor edge:
%		Actions are as for edges.}
%		}			  			   	
	    }

    \section{The graph:}{
	\itemize{
	    \item{Create a slave window:}{Select "Copy: Make slave window".}
	    \item{Redraw (zoom out):}{From the lists of objects - Select
		"Redraw the graph window".}
	    \item{Update:}{Faster fix of "corrupted" window:
                  Select "Update the graph window".}
	    \item{Export the graph lattice :}{Select
		"Assign Graph-lattice in .GlobalEnv".}
	    \item{Export the graph window:}{Select
		"Assign Graph-window in .GlobalEnv".}
	    \item{Export the object:}{Select
		"Assign Object in .GlobalEnv".}
	}			  			   	
    }			  			   	
    
    \section{Rotation:}{
	\itemize{
	    \item{Enable rotation:}{Select
		"Enable (reset) transformation" from the main menu "Graph".}
	    \item{Rotate the graph:}{Middle click the canvas, and drag.}
	    \item{Disable rotation:}{Select
		"Disable transformation" from the main menu "Graph".}
	    \item{Export transformation:}{Export the projection
		matrix - Select
		"Assign Transformation in .GlobalEnv"
                from the main menu "Graph".}
	}			  			   	
    }			  			   	
    
{}

% http://www.math.auc.dk/gr/material/CoCo/
% http://www.jbs.agrsci.dk/Biometry/Software-Datasets/CoCo/CoCo.1.6/

\section{Acknowledgments}{
Many thanks to the gR-group for useful discussions, especially to 
Claus Dethlefsen for testing early versions of this package on DEAL.
}

\references{
     CoCo, avaliable form \url{http://www.math.auc.dk/gr/material/CoCo} and
     \url{http://www.jbs.agrsci.dk/}
     \code{Biometry/Software-Datasets/CoCo/CoCo.1.6/}
     with a guide at \url{http://www.jstatsoft.org/v06/i04/},
     has an interface to \code{\link{dynamicGraph}}. }

\author{Jens Henrik Badsberg}

\note{
     Vertices, edges, blocks, block edges,
     factors, and factor edges are objects of the following classes:
     \code{\link{VertexProto}}, \code{\link{EdgeProto}},
     and \code{\link{BlockProto}} contains \code{\link{NodeProto}},
     \code{\link{FactorVertexProto}} contains \code{\link{VertexProto}}, and
     \code{\link{VertexEdgeProto}}, \code{\link{BlockEdgeProto}}, 
     \code{\link{FactorEdgeProto}} contains \code{\link{EdgeProto}}.

     The methods 
     \code{\link{draw}},
     \code{\link{color}},
     \code{\link{color<-}},
     \code{\link{label}},
     \code{\link{label<-}},
     \code{\link{labelPosition}},
     \code{\link{labelPosition<-}},
     \code{\link{name}},
     \code{\link{name<-}},
     \code{\link{index}},
     \code{\link{index<-}},  
     \code{\link{position}},
     \code{\link{position<-}},
     \code{\link{stratum}},
     \code{\link{stratum<-}},
     \code{\link{visible}},
     \code{\link{visible<-}},
     \code{\link{addToPopups}},
     \code{\link{oriented}},
     \code{\link{oriented<-}},
     \code{\link{width}},
     \code{\link{width<-}},
     \code{\link{nodeIndicesOfEdge}},
     \code{\link{nodeIndicesOfEdge<-}},
     \code{\link{nodeTypesOfEdge}},
     % ( \code{\link{labelOfEdge}},
     %   \code{\link{labelOfEdge<-}},
     %   \code{\link{widthOfEdge}},
     %   \code{\link{widthOfEdge<-}} ),
     \code{\link{ancestors}},
     \code{\link{ancestors<-}},
     \code{\link{descendants}}, and
     \code{\link{descendants<-}},
     are implemented for objects of these classes.

     For lists of vertices, edges, blocks, block edges,
     factors, and factor edges the methods
     \code{\link{Names}},
     \code{\link{Names<-}},
     \code{\link{Colors}},
     \code{\link{Colors<-}},
     \code{\link{Labels}},
     \code{\link{Labels<-}},
     \code{\link{LabelPositions}},
     \code{\link{LabelPositions<-}},
     \code{\link{Positions}},
     \code{\link{Positions<-}},
     \code{\link{Strata}},
     \code{\link{Strata<-}},
     \code{\link{Indices}},
%    \code{\link{Indices<-}},
%     \code{\link{Visible}},
%     \code{\link{Visible<-}},
     \code{\link{NodeAncestors}},
     \code{\link{NodeAncestors<-}},
     \code{\link{NodeDescendants}}, and
     \code{\link{NodeDescendants<-}} are available.

     The block tree created by \code{\link{setTreeBlocks}} is unlisted by
     \code{\link{blockTreeToList}} such that the above methods
     can be applied.

     The model object of the call of \code{\link{dynamicGraphMain}}
     should have the methods \code{modifyModel} and \code{testEdge}.
     When the graph is modified, by adding or dropping vertices or edge,
     the method \code{modifyModel} is called on the argument \code{object}
     of \code{\link{dynamicGraphMain}}. If an \code{object} is returned in
     the list of the returned value from \code{modifyModel} then
     \code{object} in \code{\link{dynamicGraphMain}} is replaced by this
     object, and the object is also assigned in the top level environment,
     if \code{objectName} was given to \code{\link{dynamicGraphMain}}.

     The method \code{testEdge} of \code{object} should return an object with
     the methods \code{label} and \code{width} for labeling edges,
     see \code{\link{newDefaultTestObject}}.

 }

% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{See also \code{\link{DynamicGraph}} and all the other functions
	of this package. 

      An example has been divided on the following 4 manual pages:
      \code{\link{newDefaultModelObject}} and
      \code{\link{newDefaultTestObject}}
      gives an example of a model object with test object.
      The pages of \code{\link{redrawGraphWindow}} show how the user 
      can add menu items with actions that redraws the graph
      after modification of edges.
      Finally, \code{\link{validVertexClasses}} show how to create
      a new vertex class with a new symbol for drawing the vertex 
      and an item added to the pop up menu of the new vertex class.
      The files \code{".../dynamicGraph/Tests/Circle.newClass.R"} of
      the example catalog of \code{dynamicGraph} will do this example
      collected from these 4 pages.
}

\examples{

require(tcltk)
require(dynamicGraph)

V.Names <- paste(c("Sex", "Age", "Eye", "FEV", "Hair", "Shosize"),
                 1:6, sep ="/")

V.Types <- c("Discrete", "Ordinal", "Discrete",
             "Continuous", "Discrete", "Continuous")

Vertices <- returnVertexList(V.Names, types = V.Types, color = "red")

From <- c(1, 2, 3, 4, 5, 6)
To   <- c(2, 3, 4, 5, 6, 1)

EdgeList <- vector("list", length(To))
for (j in seq(along = To)) EdgeList[[j]] <- c(From[j], To[j])
Edges <- returnEdgeList(EdgeList, Vertices, color = "black")

Z <- dynamicGraphMain(Vertices, edgeList = Edges, w = 4)

}
\keyword{ dplot }
\keyword{ hplot }
\keyword{ iplot }
\keyword{ dynamic }
\keyword{ graphs }
\keyword{ methods }
\keyword{ multivariate }

\eof
\name{modalDialog}
\alias{modalDialog}
\title{Modal dialog window for returning a text string}
\description{
  Ask for a text string in a pop up window.
}
\usage{
modalDialog(title, question, entryInit, top = graphWindow@top,
            entryWidth = 20, returnValOnCancel = "ID_CANCEL",
            graphWindow = NULL, do.grab = FALSE)
}

% Modal Dialog Boxes

% A modal dialog box requires the user to respond to it before changing the focus to other windows within the application. The Tk command tk_dialog is designed for this purpose, and can be called in R TclTk, using the tkdialog function. However, the method illustrated below will use the tktoplevel function and call tkgrab.set and tkgrab.release explicitly, rather than relying on tkdialog to call them automatically.

% Modal Dialog Box Example

% The following example defines a subroutine which creates a simple modal dialog box using tktoplevel to create the dialog window, and using tkgrab.set and tkgrab.release to force the user to respond to this dialog before changing focus to other window(s) in the applciation.

%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{title}{ Text string for the title bar of the appering window. }
  \item{question}{ Text string for the \code{question}. }
  \item{entryInit}{ Default value of answer. }
  \item{top}{ Text string for the \code{TclTk} \code{top}. }
  \item{entryWidth}{ Integer for the \code{entryWidth}. }
  \item{returnValOnCancel}{ Text
        string for the returned value on \code{Cancel}. }
  \item{graphWindow}{ \code{graphWindow} can be given to give the \code{top}. }
  \item{do.grab}{ Logical. 
        \code{tkgrab.set} resulted in fail for some systems. }
}
% \details{ }
\value{
    The text string entered, or \code{returnValOnCancel}.
}
\references{\url{http://bioinf.wehi.edu.au/~wettenhall/RTclTkExamples/modalDialog.html}}
\author{From the examples compiled by James Wettenhall.}
% \note{ }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
Menus <- 
 list(MainUser = 
      list(label = "Test of user drag down menu - Position of \"vertices\"",
           command = function(object, ...) 
             print(Positions(list(...)$Arguments$vertexList))),
      MainUser = 
      list(label = "Test of user drag down menu - modalDialog",
           command = function(object, ...) {
             Args <- list(...)$Arguments
             ReturnVal <- modalDialog("Test modalDialog Entry", "Enter name",
                                      Args$title, graphWindow = Args$graphWindow)
             print(ReturnVal)
             if (ReturnVal == "ID_CANCEL")
               return() } )
     )
}
\keyword{ dynamic }


\eof
\name{nameToVertexIndex}
\alias{nameToVertexIndex}
\title{ The indices of vertices }
\description{
  For each name, find in a list of vertices the index of the vertex with that name.
}
\usage{
nameToVertexIndex(vertexnames, vertices)
}
\arguments{
  \item{vertexnames}{ Vector of text strings of the \code{vertexnames}
      of the vertices for which the indices should be found.  }
  \item{vertices}{ A list of \code{vertices},
                   of each of class containing the class \code{NodeProto}. }
}
% \details{ }
\value{
  Integer vector with the indices of the vertices.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
Names <- c("Sex", "Age", "Eye", "FEV", "Hair", "Shosize")
Types <- rep("Discrete", 6)
vertices <- returnVertexList(Names, types = Types)
nameToVertexIndex(c("Sex", "Eye"), vertices)
}
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newBlock}
\alias{newBlock}
\alias{BlockProto}
\alias{closed}
\alias{closed<-}
\alias{ancestors}
\alias{ancestors<-}
\alias{descendants}
\alias{descendants<-}
\title{The block object}
\description{Returns an object of class \code{BlockProto}.}
\usage{
newBlock(stratum = 0, index = 0, position = matrix(rep(0, 6), ncol = 3),
         closed = FALSE, visible = TRUE, color = "Grey", label = "Label",
         label.position = c(0, 0, 0), ancestors = NULL)
}
\arguments{
  \item{stratum}{ Integer for the \code{stratum} of the block. 
	% The block is identified by this stratum, and thus the
        % strata of the blocks are different and unique.
        % Each vertex can only belong to one block,
	% and thus has assigned one stratum.
        }
  \item{index}{ Integer for the \code{index} of the block. }
  \item{position}{ Numeric vector for the \code{position} of the block,
      the two diagonal opposite corners. }
  \item{closed}{ Logical, if TRUE then the block is drawn as a "vertex". }
  \item{visible}{ Logical, if TRUE then the block is drawn. }
  \item{color}{ Text string for the \code{color} of the block. }
  \item{label}{ Text string for the \code{label} of the block. }
  \item{label.position}{ Numeric vector for the \code{label.position} 
                         of the block label. }
  \item{ancestors}{ Integer vector for the \code{ancestor} blocks of the
                    block. 
                    The slot with the \code{descendant} blocks is set
                    after the creation of the block. }
}
% \details{ }
\value{A object of class \code{BlockProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{
    The \code{BlockProto} class has the methods
    \code{\link{name}}, \code{\link{label}}, \code{\link{labelPosition}},
    \code{\link{position}}, \code{\link{color}}, \code{\link{stratum}},
    \code{\link{index}}, \code{\link{visible}},
    \code{\link{ancestors}}, and \code{\link{descendants}},
    for extracting values
    and the replacement methods
    % \code{\link{name<-}}, 
    \code{\link{label<-}}, \code{\link{labelPosition<-}},
    \code{\link{position<-}}, \code{\link{color<-}}, \code{\link{stratum<-}},
    \code{\link{index<-}}, \code{\link{visible<-}},
    \code{\link{ancestors<-}}, and \code{\link{descendants<-}}.
    Items are added to the pop up menu of a block
    by the method \code{\link{addToPopups}}.

    I have not yet had any use of a block name.
    Thus this slot is not available for the block,
    as neither for edges.
}
\seealso{\code{\link{newVertex}}}
\examples{
b <- newBlock()
str(b)

color(b)
label(b)
labelPosition(b)
name(b)
index(b)
position(b)
stratum(b)
ancestors(b)
descendants(b)
visible(b)

color(b) <- "grey"
label(b) <- "NameAndLabel"
labelPosition(b) <- c(1, 2, 3)
# name(b) <- "NameAndLabel" # Not possible!!!
index(b) <- 3
position(b) <- matrix(c( 10,  20,  30,  40, 
                        110, 120, 130, 140), byrow = TRUE, ncol = 4)
stratum(b) <- 1
ancestors(b) <- c(1, 2)
descendants(b) <- c(4, 5)
visible(b) <- FALSE

str(b)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newBlockEdge}
\alias{newBlockEdge}
\alias{BlockEdgeProto}.
\title{The block edge object}
\description{Returns an object of the class \code{BlockEdgeProto}
  for an edge between blocks or between a block and a vertex.}
\usage{
newBlockEdge(node.indices, nodes = NULL, width = 2,
             color = "DarkOliveGreen", oriented = TRUE, type = NULL,
             label = ifelse(is.null(nodes), "",
                            paste(Labels(nodes), collapse = "~")))
}
\arguments{
  \item{node.indices}{ Vector with \code{abs(node.indices)}
                       the indices of the nodes of the block edge.
                       If the index is positiv then the node is a vertex,
                       else it is a block. }
  \item{nodes}{ List with the \code{nodes} of the block edge. Used for
      setting the default label. }
  \item{width}{ Numeric for the \code{width} of the block edge. }
  \item{color}{ Text string with the \code{color} of the block edge. }
  \item{oriented}{ Logical. If TRUE then the block edge is \code{oriented}. }
  \item{type}{ Text string with the \code{type} of the block edge. }
  \item{label}{ Text string with the \code{label} of the block edge. }
}
\details{
The function is used in \code{\link{returnBlockEdgeList}}.
\code{\link{dynamicGraphMain}} will automatic update block edges
when vertices are moved between blocks.
}
\value{A object of class \code{BlockEdgeProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
   The methods of \code{\link{EdgeProto}}
   also applies for \code{BlockEdgeProto}.
}
\seealso{\code{\link{newVertexEdge}}}
\examples{ 
vertices <- returnVertexList(paste("V", 1:4, sep = ""))
block <- newBlock(stratum = 1)
blockedge <- newBlockEdge(c(4, -1), list(vertices[[1]], block))

str(blockedge)

color(blockedge)
label(blockedge)
labelPosition(blockedge)
width(blockedge)
nodeIndicesOfEdge(blockedge)
nodeTypesOfEdge(blockedge)

color(blockedge) <- "Black"
label(blockedge) <- "V1~1"
labelPosition(blockedge) <- c(0, 1, 2)
width(blockedge) <- 1
nodeIndicesOfEdge(blockedge) <- c(1, -1)

str(blockedge)
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newDefaultModelObject}
\alias{newDefaultModelObject}
\alias{modifyModel}
\alias{testEdge}
\title{The model object}
\description{Returns an object of the class \code{defaultModelObjectProto}.}
\usage{newDefaultModelObject(name)}
\arguments{\item{name}{ Text string with the \code{name} of the model object.}}
\details{ 
This is an example of the object for interface between
\code{\link{dynamicGraphMain}} and your models.
The model object of the call of \code{\link{dynamicGraphMain}}
should have the methods \code{modifyModel} and \code{testEdge}.
When the graph is modified, by adding or dropping vertices or edge,
the method \code{modifyModel} is called on the argument \code{object}
of \code{\link{dynamicGraphMain}}. If an \code{object} is returned in
the list of the returned value from \code{modifyModel} then
\code{object} in \code{\link{dynamicGraphMain}} is replaced by this
object, and the object is also assigned in the top level environment,
if  \code{objectName} was given to \code{\link{dynamicGraphMain}}.

The methods \code{testEdge} of \code{object} should return an object with
the methods \code{label} and \code{width} for labeling edges,
see \code{\link{newDefaultTestObject}}.
}
\value{An object of class \code{defaultModelObjectProto}.}
\references{ 
    CoCo, with a guide at \url{http://www.jstatsoft.org/v06/i04/},
    avaliable form \url{http://www.math.auc.dk/gr/material/CoCo/} and
    \url{http://www.jbs.agrsci.dk/Biometry/Software-Datasets/CoCo/CoCo.1.6/}
    has an interface to \code{\link{dynamicGraph}}. }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{\code{\link{newDefaultTestObject}}}
\examples{

# Edit the following to meet your needs:
#
# - Change the name "defaultModelObjectProto"
#
# - Work out how the get names, types and edges from the model object.
#
# - At "message", insert the relevant code for testing and modifying the model.
#


setClass("defaultModelObjectProto", representation(name = "character"))

"newDefaultModelObject"<-
  function(name)
  {
    result <- new("defaultModelObjectProto", name = name)
    return(result)
  }

if (!isGeneric("dynamic.Graph")) {
  if (is.function("dynamic.Graph"))
    fun <- dynamic.Graph
  else
    fun <- function(object, ...)
  standardGeneric("dynamic.Graph")
  setGeneric("dynamic.Graph", fun)
}

setMethod("dynamic.Graph", signature(object = "defaultModelObjectProto"),
          function(object, ...)
  {

    Names <- Your.function.for.extracting.variable.names.from.object(
             object = object)
    Types <- Your.function.for.extracting.variable.types.from.object(
             object = object)
    Edges <- Your.function.for.extracting.variable.edges.from.object(
             object = object)

    DynamicGraph(names = Names, types = Types, 
                 from = Edges[,1], to = Edges[,2], 
                 object = object, ...)
 })

if (!isGeneric("testEdge")) {
  if (is.function("testEdge"))
    fun <- testEdge
  else
    fun <- function(object, action, name.1, name.2, ...) 
           standardGeneric("testEdge")
  setGeneric("testEdge", fun)
}

setMethod("testEdge", signature(object = "defaultModelObjectProto"),
          function(object, action, name.1, name.2, ...)
 {
    args <- list(...)
    from.type <- args$from.type
    to.type <- args$to.type
    f <- function(type) if(is.null(type)) "" else paste("(", type, ")")
    message(paste("Should return an object with the edge from",
                  name.1, f(from.type), "to", name.2, f(to.type),
                  "deleted from the argument object"))
    return(newDefaultTestObject())
 })

if (!isGeneric("modifyModel")) {
  if (is.function("modifyModel"))
    fun <- modifyModel
  else
    fun <- function(object, action, name, name.1, name.2, ...)
                    standardGeneric("modifyModel")
  setGeneric("modifyModel", fun)
}

setMethod("modifyModel", signature(object = "defaultModelObjectProto"),
          function(object, action, name, name.1, name.2, ...)
 {
    args <- list(...)
    FactorVertices <- NULL
    FactorEdges <- NULL
    f <- function(type) if(is.null(type)) "" else paste("(", type, ")")
    if (action == "dropEdge") {
       message(paste("Should return an object with the edge from",
                     name.1, f(args$from.type), "to", name.2, f(args$to.type),
                     "deleted from the argument object"))
    } else if (action == "addEdge") {
       message(paste("Should return an object with the edge from",
                     name.1, f(args$from.type), "to", name.2, f(args$to.type),
                     "added to the argument object"))
    } else if (action == "dropVertex")  {
       message(paste("Should return an object with the vertex", 
                     name, f(args$type), "deleted from the argument object"))
       if (!is.null(args$Arguments) && (args$index > 0)
                       && !is.null(args$Arguments$factorVertexList)
                       && !is.null(args$Arguments$vertexList)) {
         x <- (args$Arguments$factorVertexList)
         factors <- lapply(x, function(i) i@vertex.indices)
         types <- lapply(x, function(i) class(i))
         factors <- lapply(factors, function(x) x[x != args$index])
         if (!(is.null(factors))) {
           result <- returnFactorVerticesAndEdges(
                                   args$Arguments$vertexList, factors, types, 
                                   factorClasses = validFactorClasses())
           FactorVertices <- result$FactorVertices
           FactorEdges <- result$FactorEdges
         }
       }
    } else if (action == "addVertex") {
       message(paste("Should return an object with the vertex", 
                     name, f(args$type), args$index, 
                     "added to the argument object"))
    }
    return(list(object = object,
                FactorVertices = FactorVertices,
                FactorEdges = FactorEdges))
 })

newDefaultModelObject("ModelObject")

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newDefaultTestObject}
\alias{newDefaultTestObject}
% \alias{labelOfTest}
% \alias{widthOfTest}
\title{The test object}
\description{Returns an object of the class \code{defaultTestObjectProto}.}
\usage{newDefaultTestObject(name)}
\arguments{\item{name}{ Text string with the \code{name} of the test object.}}
\details{ 
    The methods
    \code{label} and \code{width} % (was \code{labelOfTest} and \code{widthOfTest})
    should be
    implemented by you for your test object returned by the method
    \code{testEdge} of your \code{object}. 
}
\value{An object of class \code{defaultTestObjectProto}.}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{\code{\link{newDefaultModelObject}}}
\examples{

setClass("defaultTestObjectProto", 
         representation(deviance = "numeric", df = "numeric", p = "numeric"))

"newDefaultTestObject"<-
  function(name)
  {
    df <- round(runif(1, 1, 25))
    message("Just generating a random test!!!!!")
    deviance <- rchisq(1, df)
    p <- 1 - pchisq(deviance, df)
    result <- new("defaultTestObjectProto",
                   df = df, deviance = deviance, p = p)
    return(result)
  }

if (!isGeneric("label") && !isGeneric("label", where = 2)) {
  if (is.function("label"))
    fun <- label
  else
    fun <- function(object) standardGeneric("label")
  setGeneric("label", fun)
}

setMethod("label", "defaultTestObjectProto",
          function(object) format(object@p, digits = 4))

if (!isGeneric("width") && !isGeneric("width", where = 2)) {
  if (is.function("width"))
    fun <- width
  else
    fun <- function(object) standardGeneric("width")
  setGeneric("width", fun)
}

setMethod("width", "defaultTestObjectProto",
          function(object) round(2 + 5 * (1 - object@p)))


newDefaultTestObject("TestObject")

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newFactor}
\alias{FactorVertexProto}
\alias{newFactor}
\alias{nodeIndices}
\alias{nodeIndices<-}  
\title{The factor vertex object}
\description{Returns an object of the class
    containing the class \code{FactorVertexProto}.}
\usage{
newFactor(vertex.indices, vertices = NULL, 
          name = ifelse(is.null(vertices), "", 
                        paste(Labels(vertices), collapse = ":")),
          label = name, type = "Generator",
          index = 0, width = 2, color = "default",
          factorClasses = validFactorClasses())
}
\arguments{
  \item{vertex.indices}{ Integer vector of the \code{vertex.indices} 
                         of the vertices of the factor. }
  \item{vertices}{ The \code{vertices} of the factor. Used for setting
      the default label. }
  \item{name}{ Text string for the \code{name} of the factor vertex. }
  \item{label}{ Text string for the \code{label} of the factor vertex. }
  \item{type}{ Text string for the \code{type}, e.i. the class,
      of the factor vertex. Should be in \code{factorClasses}. }
  \item{index}{ Integer for the \code{index} of the factor vertex. }
  \item{width}{ Numeric, for the \code{width} of the factor vertex. }
  \item{color}{ Text string for the \code{color} of the factor vertex. }
  \item{factorClasses}{ The valid \code{factorClasses}. }
}
% \details{ }
\value{A object of class containing \code{FactorVertexProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
   The methods (except \code{\link{stratum}})
   of \code{\link{VertexProto}}
   also applies for \code{FactorVertexProto}.
 }
\seealso{\code{\link{newVertex}}, \code{\link{validVertexClasses}}}
\examples{
vertices <- returnVertexList(paste("V", 1:4, sep = ""), 
                             types = rep("Discrete", 4))
factor <- newFactor(c(1, 2, 3), vertices[1:3], type = "Generator")

str(factor)

color(factor)
label(factor)
labelPosition(factor)
name(factor)
index(factor)
position(factor)
nodeIndices(factor)

color(factor) <- "green"
label(factor) <- "v-1-2-3"
labelPosition(factor) <- c(1, 2, 3)
name(factor) <- "V-123" 
index(factor) <- 3
position(factor) <- c( 10,  20,  30,  40)

str(factor)
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newFactorEdge}
\alias{newFactorEdge}
\alias{FactorEdgeProto}
\title{The factor edge object}
\description{Returns an object of the class \code{FactorEdgeProto}
  for an edge from a vertex to a factor node in the bipartite graph.}
\usage{
newFactorEdge(node.indices, nodes = NULL, width = 2,
              color = "DarkOliveGreen", type = NULL,
              label = ifelse(is.null(nodes), "",
                             paste(Labels(nodes), collapse = "~")))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{node.indices}{ Vector with \code{abs(node.indices)}
                       the indices of the nodes of the factor edge.
                       If the index is positiv then the node is a vertex,
                       else it is the factor vertex. }
  \item{nodes}{ List with the \code{nodes} of the factor edge. Used for
      setting the default label. }
  \item{width}{ Numeric for the \code{width} of the factor edge. }
  \item{color}{ Text string with the \code{color} of the factor edge. }
  \item{type}{ Text string with the \code{type} of the factor edge. }
  \item{label}{ Text string with the \code{label} of the factor edge. }
}
% \details{}
\value{A object of class \code{FactorEdgeProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
   The methods (except \code{\link{oriented}})
   of \code{\link{EdgeProto}}
   also applies for \code{FactorEdgeProto}.
 }
\seealso{\code{\link{newVertexEdge}}}
\examples{
vertices <- returnVertexList(paste("V", 1:4, sep = ""))
factor <- newFactor(1:3, vertices[1:3], type = "Generator")
factoredge <- newFactorEdge(c(1, -1), list(vertices[[1]], factor))
str(factoredge)

color(factoredge)
label(factoredge)
labelPosition(factoredge)
width(factoredge)
nodeIndicesOfEdge(factoredge)
nodeTypesOfEdge(factoredge)

color(factoredge) <- "Black"
label(factoredge) <- "V1~V1:2:3"
labelPosition(factoredge) <- c(0, 1, 2)
width(factoredge) <- 1
nodeIndicesOfEdge(factoredge) <- c(1, -1)
str(factoredge)
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newVertex}
\alias{NodeProto}
\alias{VertexProto}
\alias{newVertex}
\alias{draw}
\alias{color}
\alias{color<-}
\alias{label}
\alias{label<-}
\alias{labelPosition}
\alias{labelPosition<-}
\alias{name}
\alias{name<-}
\alias{index}
\alias{index<-}  
\alias{position}
\alias{position<-}
\alias{stratum}
\alias{stratum<-}
\alias{blockindex}
\alias{blockindex<-}
\alias{visible}
\alias{visible<-}
\alias{addToPopups}
\title{The vertex object}
\description{Returns an object of a class containing \code{VertexProto}.}
\usage{
newVertex(name, label = name, type = "VertexProto", index = 1,
          position = c(0, 0, 0), blockindex = 0, stratum = 0,
          color = ifelse(type == "TextVertex", "GhostWhite", "SaddleBrown"),
          vertexClasses = validVertexClasses())
}
\arguments{
  \item{name}{ Text string with the \code{name} of the vertex. 
     Should be a valid name on variables for your model object. }
  \item{label}{ Text string with the \code{label} of the vertex. }
  \item{type}{ Text string with the \code{type} of the vertex. 
     This \code{type} is the label of class of the vertex,
     the labels of \code{\link{vertexClasses}}. }
  \item{index}{ Integer with the \code{index} of the vertex,
     the position in a vertex list. }
  \item{position}{ Numeric vector with the \code{position} of the vertex.
     Vertices in the same dynamic graph should
     have the same number of coordinates. }
  \item{blockindex}{ Integer with the \code{blockindex} of the vertex. }
  \item{stratum}{ Integer with the \code{stratum} of the vertex. }
  \item{color}{ Text string with the \code{color} of the vertex. }
  \item{vertexClasses}{ The valid \code{vertexClasses}. }
}
% \details{ }
\value{A object of a class containing the class \code{VertexProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
    The \code{VertexProto} class has the methods
    \code{\link{name}}, \code{\link{label}}, \code{\link{labelPosition}},
    \code{\link{position}}, \code{\link{stratum}},
    % \code{\link{visible}},
    \code{\link{color}}, and \code{\link{index}}
    for extracting values of the object and the replacement methods
    \code{\link{name<-}}, \code{\link{label<-}}, \code{\link{labelPosition<-}},
    \code{\link{position<-}}, \code{\link{stratum<-}}, 
    % \code{\link{visible<-}},
    \code{\link{color<-}}, and \code{\link{index<-}}.
    The method \code{\link{draw}} is used to draw a vertex,
    and items can be added to the pop up menu of the vertex
    by the method \code{\link{addToPopups}}.
    
    Some of these methods also applies for 
    edges (\code{\link{EdgeProto}}),
    blocks (\code{\link{BlockProto}}), 
%    edges between block and between blocks and vertices
    block edges
    (\code{\link{BlockEdgeProto}}),
    factor vertices (\code{\link{FactorVertexProto}})
    and edges from vertices to factors (\code{\link{FactorEdgeProto}}).
}
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{

a <- newVertex("a", "A", "Discrete", 1, c(0, 0, 0))

str(a)

color(a)
label(a)
labelPosition(a)
name(a)
index(a)
position(a)
stratum(a)

color(a) <- "red"
label(a) <- "A vertex"
labelPosition(a) <- c(1, 2, 3)
name(a) <- "Capital.A"
index(a) <- -1
position(a) <- c(10, 20, 30)
stratum(a) <- 1

str(a)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{newVertexEdge}
\alias{EdgeProto}
\alias{VertexEdgeProto}
\alias{newVertexEdge}
% \alias{labelOfEdge}
% \alias{widthOfEdge}
% \alias{labelOfEdge<-}
% \alias{widthOfEdge<-}
% \alias{edgeLabel}
% \alias{edgeWidth}
% \alias{edgeLabel<-}
% \alias{edgeWidth<-}
\alias{nodeIndicesOfEdge}
\alias{nodeIndicesOfEdge<-}
\alias{nodeTypesOfEdge}
% \alias{nodeTypesOfEdge<-}
\alias{width}
\alias{width<-}
\alias{oriented}
\alias{oriented<-}
\title{The edge object}
\description{Returns an object of the class \code{EdgeProto}
  for an edge between vertices. }
\usage{
newVertexEdge(vertex.indices, vertices = NULL, width = 2,
              color = "DarkOliveGreen", oriented = FALSE, type = NULL,
              label = ifelse(is.null(vertices), "",
                             paste(Labels(vertices), collapse = "~")))
}
\arguments{
  \item{vertex.indices}{ Integer vector of the \code{vertex.indices} 
      of the vertices of the edge. These are the indices of the
      vertices in the list of vertices. }
  \item{vertices}{ All the \code{vertices} of the edge, and only the
     vertices of the edge. Currently, only used for setting the default label. }
  \item{width}{ Numeric, for the \code{width} of the edge. }
  \item{color}{ Text string for the \code{color} of the edge. }
  \item{oriented}{ Logical, TRUE if the edge is \code{oriented},
      also when no blocks are used in \code{\link{dynamicGraphMain}}. }
  \item{type}{ Text string for the \code{type} of the edge. 
      Currently not used. 
      Intended to set which class the edge should be class of
      containing the  class \code{EdgeProto}.}
  \item{label}{ Text string for the \code{label} of the edge.
                By default set by concatenating the labels of the vertices. }
}
\details{
    Edges are not constrained to have two vertices.
}
\value{A object of class \code{EdgeProto}. }
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{
    The \code{EdgeProto} class has
    beside the methods of \code{\link{VertexProto}}
    the methods \code{\link{oriented}} and \code{\link{oriented<-}}.

    % The methods
    % \code{\link{labelOfEdge}}, \code{\link{widthOfEdge}},
    % \code{\link{labelOfEdge<-}}, \code{\link{widthOfEdge<-}}
    % are available because of some problems with the methods
    % \code{\link{label}}, \code{\link{width}},
    % \code{\link{label<-}}, and \code{\link{width<-}} 
    % for edges and \code{NAMESPACES}.
    % These problems are solved, and the methods
    % \code{...OfEdge} will  be removed very soon.

    The method \code{\link{nodeIndicesOfEdge}} will extract the indices of the
    vertices of the edge, and the method \code{\link{nodeTypesOfEdge}} will
    extract the types
    ("super classes": \code{vertex}, \code{factor} or \code{block})
    of the vertices (nodes) of an edge.
    The method \code{\link{draw}} is used to draw the edge,
    and items are added to the pop up menu of an edge
    by the method \code{\link{addToPopups}}.

    Some of these methods also applies for
    block edges (\code{BlockEdgeProto})
    and factor edges (\code{FactorEdgeProto}).
}
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
vertices <- returnVertexList(paste("V", 1:4, sep = ""))
e <- newVertexEdge(c(1, 2, 3), vertices = vertices[1:3])

str(e)

color(e)
label(e)
labelPosition(e)
width(e)
oriented(e)
nodeIndicesOfEdge(e)
nodeTypesOfEdge(e)

color(e) <- "Black"
label(e) <- "1-2"
labelPosition(e) <- c(10, 20, 30)
width(e) <- 1
oriented(e) <- TRUE
nodeIndicesOfEdge(e) <- c(1, 2)

str(e)
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{redrawGraphWindow}
\alias{redrawGraphWindow}
\alias{menu}
\title{Redraw the dynamicGraph window and draw slaves}
\description{
    To redraw the graph window and to draw slave graph windows.
}
% \usage{
% redrawGraphWindow(graphLattice = NULL, graphWindow = NULL, 
%                   edgeList = NULL, blockEdgeList = NULL, 
%                   factorVertexList = NULL, factorEdgeList = NULL, 
%                   visibleVertices = NULL, extraList = NULL, 
%                   object = NULL, title = "dynamicGraph", 
%                   transformation = NULL, width = NULL, height = NULL, 
%                   w = NULL, 
%                   vertexColor = NULL, extraVertexColor = NULL, 
%                   edgeColor = NULL, factorVertexColor = NULL, 
%                   factorEdgeColor = NULL, blockEdgeColor = NULL, 
%                   blockColors = NULL, background = NULL, ...)
% }
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{graphLattice}{ NULL, or \code{graphLattice} of 
      \code{list(...)$Arguments} }
  \item{graphWindow}{ If \code{graphWindow} is set to 
      the value of \code{list(...)$Arguments$graphWindow} then
      the calling graph window will be redrawn.
      If \code{graphWindow} is set to \code{NULL}, the default value,
      then a new slave graph window will be drawn. }
  \item{edgeList}{ As for \code{\link{dynamicGraphMain}}.
        If \code{edgeList} is given then this value is used,
        else the value extracted from \code{list(...)$Arguments} is used. }
  \item{blockEdgeList}{ As for \code{\link{dynamicGraphMain}}.
        If \code{blockEdgeList} ... (as for \code{edgeList}). }
  \item{factorVertexList}{ As for \code{\link{dynamicGraphMain}}.
        If \code{factorVertexList} ... (as for \code{edgeList}). }
  \item{factorEdgeList}{ As for \code{\link{dynamicGraphMain}}.
        If \code{factorEdgeList} ... (as for \code{edgeList}). }
  \item{visibleVertices}{ As for \code{\link{dynamicGraphMain}}.
        If \code{visibleVertices} ... (as for \code{edgeList}). }
  \item{extraList}{ As for \code{\link{dynamicGraphMain}}.
        If \code{extraList} ... (as for \code{edgeList}). }
  \item{object}{ As for \code{\link{dynamicGraphMain}}.
        If \code{object} ... (as for \code{edgeList}). }
  \item{title}{ As for \code{\link{dynamicGraphMain}}.
        If \code{title} ... (as for \code{edgeList}). }
  \item{transformation}{ As for \code{\link{dynamicGraphMain}}.
        If \code{transformation} ... (as for \code{edgeList}). }
  \item{width}{ As for \code{\link{dynamicGraphMain}}.
        If \code{width} ... (as for \code{edgeList}). }
  \item{height}{ As for \code{\link{dynamicGraphMain}}.
        If \code{height} ... (as for \code{edgeList}). }
  \item{w}{ As for \code{\link{dynamicGraphMain}}.
        If \code{w} ... (as for \code{edgeList}). }
  \item{vertexColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{vertexColor} ... (as for \code{edgeList}). }
  \item{extraVertexColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{extraVertexColor} ... (as for \code{edgeList}). }
  \item{edgeColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{edgeColor} ... (as for \code{edgeList}). }
  \item{factorVertexColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{factorVertexColor} ... (as for \code{edgeList}). }
  \item{factorEdgeColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{factorEdgeColor} ... (as for \code{edgeList}). }
  \item{blockEdgeColor}{ As for \code{\link{dynamicGraphMain}}.
        If \code{blockEdgeColor} ... (as for \code{edgeList}). }
  \item{blockColors}{ As for \code{\link{dynamicGraphMain}}.
        If \code{blockColors} ... (as for \code{edgeList}). }
  \item{background}{ As for \code{\link{dynamicGraphMain}}.
        If \code{background} ... (as for \code{edgeList}). }
  \item{\dots}{ Used to porting \code{list(...)$Arguments}. }
}
\details{
  This function can be called from the functions of menus 
  (main menu and pop up menus) of \code{\link{dynamicGraphMain}}
  (and from the methods of the model object in the scope of
  the function \code{\link{dynamicGraphMain}}).
  As a result the graph window will be redrawn,
  possible with, e.g., other edges,
  or a new slave graph window will appear.

  If the value of a argument to \code{redrawGraphWindow} is set,
  then this value is used, else the value from the calling window is used.
  The value of the calling window is given in the argument
  \code{Arguments} in the call of the function of the menu item.

  Below is an example, where items for labeling all the edges
  of the graph are added to the menu.
  The edges are visited, a test is computed for each edge,
  the label and width of the edge is updated, and the
  graph is drawn with the updated edge list.
}
\value{
  The returned value from \code{\link{dynamicGraphMain}}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
    The function can not be called from top level. }
\seealso{ See also \code{\link{dynamicGraphMain}}. }
\examples{

myLabelAllEdges <- function(object, slave = FALSE, ...) 
 {
  args <- list(...)
  Args <- args$Arguments

  getNodeName <- function(index, type)
    if (type == "Vertex")
      name(Args$vertexList[[index]])
    else if (type == "Factor")
      name(Args$factorVertexList[[abs(index)]])
    else if (type == "Block")
      label(Args$blockList[[abs(index)]])
    else
      NULL

  visitEdges <- function(edges) {
    for (i in seq(along = edges)) {
      vertices <- nodeIndicesOfEdge(edges[[i]])
      types    <- nodeTypesOfEdge(edges[[i]])
      name.f <- getNodeName(vertices[1], types[1])
      name.t <- getNodeName(vertices[2], types[2])
      R <- testEdge(object, action = "remove",
                    name.1 = name.f, name.2 = name.t,
                    from = vertices[1], to = vertices[2],
                    from.type = types[1], to.type = types[2],
                    edge.index = i, force = force, Arguments = Args)
      if (!is.null(R)) {
        if (TRUE || (hasMethod("label", class(R))))
          label(edges[[i]]) <- label(R)
        if (TRUE || (hasMethod("width", class(R))))
          width(edges[[i]]) <- width(R)
      }
    }
    return(edges)
  }

  edgeList <- visitEdges(Args$edgeList)
  factorEdgeList <- visitEdges(Args$factorEdgeList)
  blockEdgeList <- visitEdges(Args$blockEdgeList)

  if (slave)
    Args$redrawGraphWindow(graphWindow = NULL, 
                           edgeList = edgeList,
                           factorEdgeList = factorEdgeList,
                           blockEdgeList = blockEdgeList,
                           title = "A slave window", ...)
  else
    Args$redrawGraphWindow(graphWindow = Args$graphWindow,
                           edgeList = edgeList,
                           factorEdgeList = factorEdgeList,
                           blockEdgeList = blockEdgeList,
                           title = "Not used!", 
                           width = NULL, height = NULL, 
                           Arguments = Args)
 }


Menus <- 
 list(MainUser = 
      list(label = "Test of user drag down menu - Position of \"vertices\"",
           command = function(object, ...) 
             print(Positions(list(...)$Arguments$vertexList))),
      MainUser = 
      list(label = "Label all edges, in this window",
           command = function(object, ...) 
                       myLabelAllEdges(object, slave = FALSE, ...)),
      MainUser = 
      list(label = "Label all edges, in slave window",
           command = function(object, ...) 
                       myLabelAllEdges(object, slave = TRUE, ...)),
      MainUser = 
      list(label = "Test of user drag down menu - modalDialog",
           command = function(object, ...) {
             Args <- list(...)$Arguments
             ReturnVal <- modalDialog("Test modalDialog Entry",
                                      "Enter name", Args$title,
                                      # top = Args$graphWindow@top,
                                      graphWindow = Args$graphWindow)
             print(ReturnVal)
             if (ReturnVal == "ID_CANCEL")
               return() } ),
      Vertex = 
      list(label = "Test of user popup menu for vertices",
           command = function(object, name, ...) {
             print(name)
             print(c(list(...)$index)) } ),
      Edge = 
      list(label = "Test of user popup menu for edges",
           command = function(object, name1, name2, ...) {
             args <- list(...)
             print(c(name1, name2))
             print(c(args$edge.index, args$from, args$to)) } ),
      ClosedBlock = 
      list(label = "Test of user popup menu for blocks",
           command = function(object, name, ...) {
             print(name)
             print(c(list(...)$index)) } )
     )
}
\keyword{ methods }% at least one, from doc/KEYWORDS
\keyword{ multivariate }% __ONLY ONE__ keyword per line

\eof
\name{returnBlockEdgeList}
\alias{blockEdgeList}
\alias{returnBlockEdgeList}
\title{ The block edge list }
\description{
  Return a list of block edges, each of class \code{BlockEdgeProto}.
}
\usage{
returnBlockEdgeList(edge.list, vertices, blocks, width = 2, 
                    color = "default", oriented = FALSE, type = NULL)
}
\arguments{
  \item{edge.list}{ A list of vectors identifying the edges (between vertices).
                    Each vector of \code{edge.list} should be a vector of 
                    integers giving the indices of the vertices of an edge, or
                    a vector of text strings with the names of the vertices. }
  \item{vertices}{ The list of \code{vertices}, 
      each of a class containing \code{VertexProto}. }
  \item{blocks}{ The list of \code{blocks}, 
      each of a class \code{BlockProto}. }
  \item{width}{ A numeric with the initial \code{width} of block edges. }
  \item{color}{
      "default", or list with one or two text strings for colors 
      giving the initial \code{color} of block edges.
      The two colors are used for respectively edges
      between blocks and for edges between blocks 
      and vertices.
    }
  \item{oriented}{ Logical, if TRUE then the edges are \code{oriented}. }
  \item{type}{ A text string giving the \code{type} of block edges. }
}
% \details{ }
\value{
    A list of block edges, each of class \code{BlockEdgeProto}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
    The methods of the edge list, \code{\link{returnEdgeList}},
    also applies for block edge lists.
 }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
Block.tree <- list(label = "W", Vertices = c("country"),
                   X = list(Vertices = c("sex", "race"),
                            A = list(Vertices = c("hair", "eye"),
                                     horizontal = FALSE),
                            B = list(Vertices = c("age"),
                                     C = list(Vertices = c("education")))))
Names <- unlist(Block.tree)
Names <- Names[grep("Vertices", names(Names))]
Types <- rep("Discrete", length(Names))
vertices <- returnVertexList(Names, types = Types)
blocktree <- setTreeBlocks(Block.tree, vertices)
blocks <- blockTreeToList(blocktree$BlockTree)
from <- c("country", "country", "race", "race",       "sex", "sex")
to   <- c(    "sex",    "race", "hair",  "eye", "education", "age")
from <- match(from, Names)
to <- match(to, Names)
edge.list <- vector("list", length(to))
for (j in seq(along = to)) edge.list[[j]] <- c(from[j], to[j])
edges <- returnEdgeList(edge.list, vertices, color = "red", oriented = TRUE)
vertices <- blocktree$Vertices
blockedges <- returnBlockEdgeList(edge.list, vertices, blocks,
                                  color = "red", oriented = TRUE)

Names(blockedges)
Colors(blockedges)
Labels(blockedges)
LabelPositions(blockedges)
# Positions(blockedges)
# Strata(blockedges)
# Indices(blockedges)
str(NodeTypes(blockedges))
str(NodeIndices(blockedges))
Widths(blockedges)
Oriented(blockedges)
Widths(blockedges) <- rep(1,  7)
Widths(blockedges) <- rep(1, 14)
Widths(blockedges)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{returnEdgeList}
\alias{vertexEdgeList}
\alias{returnEdgeList}
\alias{NodeTypes}
% \alias{NodeTypes<-}
\alias{NodeIndices}
% \alias{NodeIndices<-}
\alias{Widths}
\alias{Widths<-}
\alias{Oriented}
\alias{Oriented<-}

\alias{NodeIndices,list-method}
\alias{NodeTypes,list-method}
\alias{Widths,list-method}
\alias{Widths<-,list-method}
\alias{Oriented,list-method}
\alias{Oriented<-,list-method}

\title{ The edge list }
\description{
  Return a list of edges, each of class containing \code{VertexEdgeProto}.
}
\usage{
returnEdgeList(edge.list, vertices, width = 2, color = "DarkSlateGrey",
               oriented = FALSE, type = NULL)
}
\arguments{
  \item{edge.list}{ A list of vectors identifying the edges.
                    Each vector of \code{edge.list} should be a vector of 
                    integers giving the indices of the vertices of an edge, or 
                    a vector of text strings with the names of the vertices.}
  \item{vertices}{ The list of \code{vertices}, 
      each of a class containing \code{VertexProto}.
     \code{vertices} are used to set the initial labels of the edges.}
  \item{width}{ A single numeric with the initial \code{width} of the edges. }
  \item{color}{ A single text string giving the \code{color} of the edges. }
  \item{oriented}{ Logical, if TRUE then the edges are \code{oriented}. }
  \item{type}{ A single text string giving the \code{type} of the edges. 
     The label \code{type} of an edge class is currently not used, but
     intended to identify which class the edges should be of containing
     the \code{VertexEdgeProto}.} 
}
% \details{}
\value{
     A list of edges, each of class containing \code{VertexEdgeProto}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{
    Beside the methods of the vertex list, \code{\link{vertexList}},
    (except \code{\link{Positions}}, \code{\link{Indices}}
    and \code{\link{Strata}}) the edge list also has the methods
    \code{\link{NodeTypes}},
    % \code{\link{NodeTypes<-}},
    \code{\link{NodeIndices}},
    % \code{\link{NodeIndices<-}},
    \code{\link{Widths}},
    \code{\link{Widths<-}},
    \code{\link{Oriented}}, and
    \code{\link{Oriented<-}}. 
}
\seealso{\code{\link{vertexList}} and \code{\link{newVertexEdge}}.}
\examples{

from <- c("contry", "contry", "race", "race",       "sex",  "sex")
to   <- c(   "sex",   "race", "hair",  "eye", "education",  "age")
vertexnames <- unique(sort(c(from, to)))
vertices <- returnVertexList(vertexnames)
# from <- match(from, vertexnames)
# to <- match(to, vertexnames)
edge.list <- vector("list", length(to))
for (j in seq(along = to)) edge.list[[j]] <- c(from[j], to[j])
edges <- returnEdgeList(edge.list, vertices, color = "red", oriented = TRUE)

Names(edges)
Colors(edges)
Labels(edges)
LabelPositions(edges)
# Positions(edges)
# Strata(edges)
# Indices(edges)
str(NodeTypes(edges))
str(NodeIndices(edges))
Widths(edges)
Oriented(edges)
Widths(edges) <- rep(1, 7)
Widths(edges) <- rep(1, 6)
Widths(edges)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{returnFactorEdgeList}
\alias{factorEdgeList}
\alias{returnFactorEdgeList}
\title{ The factor edge list }
\description{
  Return a list of factor edges, each of class \code{FactorEdgeProto}.
}
\usage{
returnFactorEdgeList(edge.list, vertices, factorvertices = NULL,
                     width = 2, color = "DarkSlateGrey",
                     % oriented = FALSE,
                     type = NULL)
}
\arguments{
  \item{edge.list}{ A list of vectors identifying the edges (between vertices).
                    Each vector of \code{edge.list} should be a vector of 
                    integers giving the indices of the vertices of an edge, or
                    a vector of text strings with the names of the vertices. }
  \item{vertices}{ The list of \code{vertices}, 
      each of a class containing \code{VertexProto}. }
  \item{factorvertices}{ The list of \code{factorvertices}, 
      each of a class containing \code{FactorVertexProto}. }
  \item{width}{ A numeric with the initial \code{width} of the factor edges. }
  \item{color}{ A text string giving the initial \code{color}
        of the factor edges. }
  % \item{oriented}{ Logical, if TRUE then the edges are \code{oriented}. }
  \item{type}{ A text string giving the \code{type} of the factor edges. }
}
% \details{ }
\value{
    A list of edges, each of class \code{FactorEdgeProto}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
    The methods of the edge list, \code{\link{returnEdgeList}},
    also applies for factor edge lists.

    No example is given here since the factor edge list usually
    will be returned by the function 
    \code{\link{returnFactorVerticesAndEdges}}.
    The application is similar to \code{\link{returnBlockEdgeList}},
    see example here.

 }
\seealso{
\code{\link{returnFactorVerticesAndEdges}}
 and \code{\link{returnBlockEdgeList}}. }
% \examples{ }
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{returnFactorVerticesAndEdges}
\alias{factorVertexList}
\alias{returnFactorVerticesAndEdges}
\title{ The factor vertex list}
\description{
    Create factor vertex and factor edge lists.
}
\usage{
returnFactorVerticesAndEdges(Vertices, factors = NULL, types = "Generator", 
                             factorVertexColor = "default", 
                             factorEdgeColor = "DarkOliveGreen", 
                             % oriented = FALSE, 
                             factorClasses = validFactorClasses())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Vertices}{ The list of \code{Vertices}, each
      containing the class \code{VertexProto}. }
  \item{factors}{ The list of vectors identifying the \code{factors}.
          Each item in the list is a vector of the indices of
	  vertices of a factor. 
      }
  \item{types}{ The \code{types} of the factors. Either a single
      \code{type} or a list of the same length as \code{factors}.
      Each item of \code{types} should match the labels of
      \code{\link{factorClasses}}, and is used to set the class of
      the factor vertex.
  }
  \item{factorVertexColor}{ The \code{factorVertexColor}
      of the factor vertices. }
  \item{factorEdgeColor}{ The \code{factorEdgeColor} of the factor edges. }
  % \item{oriented}{ Logical, if TRUE then the edges are \code{oriented}. }
  \item{factorClasses}{ The valid \code{\link{factorClasses}}. }
}
\details{
      The argument \code{factors} is a list of vectors identifying 
      the \code{factors}, or \code{generators}.
      Each item in the list is a vector with of the indices (or names)
      of the vertices of a factor, or variables of a generator.
      A factor vertex is made for each factor, and factor edges
      from this factor vertex to the vertices of the factor
      or added to the factor edge list.
      Also the edges between pairs of the vertices in the factors
      are returned.
}
\value{
  A list with components
  \item{FactorVertices}{The list of factor vertices, each of class containing
        \code{\link{FactorVertexProto}}. }
  \item{FactorEdges}{The list of factor edge, each of class containing
        \code{\link{FactorEdgeProto}}.}
  \item{PairEdges}{A matrix with the edges of the graph,
        two columns with the indices of the vertices of two ends 
        of the edges. }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 
    The methods of the vertex list, \code{\link{returnVertexList}},
    also applies for factor lists,
    and the methods of the edge list, \code{\link{returnEdgeList}},
    also applies for factor edge lists.

    Your \code{\link{modifyModel}} should compute the new factors,
    generators, when modifying the model. By default only the new
    factors are computed when a vertex is deleted.
    Adding and dropping edges requires finding the cliques of the graph
    from the edges of the graph. Finding the cliques is out of the scope
    of  \code{\link{dynamicGraph}}.
 }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{

setClass("defaultModelObjectProto", representation(name = "character"))

if (!isGeneric("modifyModel")) {
  if (is.function("modifyModel"))
    fun <- modifyModel
  else
    fun <- function(object, action, name, name.1, name.2, ...)
                    standardGeneric("modifyModel")
  setGeneric("modifyModel", fun)
}

setMethod("modifyModel", signature(object = "defaultModelObjectProto"),
          function(object, action, name, name.1, name.2, ...)
 {
    args <- list(...)
    FactorVertices <- NULL
    FactorEdges <- NULL
    f <- function(type) if(is.null(type)) "" else paste("(", type, ")")
    if (action == "dropEdge") {
       message(paste("Should return an object with the edge from",
                     name.1, f(args$from.type), "to", name.2, f(args$to.type),
                     "deleted from the argument object"))
    } else if (action == "addEdge") {
       message(paste("Should return an object with the edge from",
                     name.1, f(args$from.type), "to", name.2, f(args$to.type),
                     "added to the argument object"))
    } else if (action == "dropVertex")  {
       message(paste("Should return an object with the vertex", 
                     name, f(args$type),
                     "deleted from the argument object"))
       if (!is.null(args$Arguments) && (args$index > 0)
                       && !is.null(args$Arguments$factorVertexList)
                       && !is.null(args$Arguments$vertexList)) {
         x <- (args$Arguments$factorVertexList)
         factors <- lapply(x, function(i) i@vertex.indices)
         types <- lapply(x, function(i) class(i))
         factors <- lapply(factors, function(x) x[x != args$index])
         if (!(is.null(factors))) {
           result <- returnFactorVerticesAndEdges(
                                   args$Arguments$vertexList, factors, types, 
                                   factorClasses = validFactorClasses())
           FactorVertices <- result$FactorVertices
           FactorEdges <- result$FactorEdges
         }
       }
    } else if (action == "addVertex") {
       message(paste("Should return an object with the vertex", 
                     name, f(args$type), args$index, 
                     "added to the argument object"))
    }
    return(list(object = object,
                FactorVertices = FactorVertices,
                FactorEdges = FactorEdges))
 })

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{returnVertexList}
\alias{vertexList}
\alias{returnVertexList}
\alias{Names}
\alias{Names<-}
\alias{Colors}
\alias{Colors<-}
\alias{Labels}
\alias{Labels<-}
\alias{LabelPositions}
\alias{LabelPositions<-}
\alias{Positions}
\alias{Positions<-}
\alias{Strata}
\alias{Strata<-}
\alias{Blockindices}
\alias{Blockindices<-}
\alias{Indices}
% \alias{Indices<-}
\alias{Visible}
\alias{Visible<-}

\alias{Names,list-method}
\alias{Names<-,list-method}
\alias{Colors,list-method}
\alias{Colors<-,list-method}
\alias{Labels,list-method}
\alias{Labels<-,list-method}
\alias{LabelPositions,list-method}
\alias{LabelPositions<-,list-method}
\alias{Positions,list-method}
\alias{Positions<-,list-method}
\alias{Strata,list-method}
\alias{Strata<-,list-method}
\alias{Blockindices,list-method}
\alias{Blockindices<-,list-method}
\alias{Indices,list-method}
\alias{Visible,list-method}
\alias{Visible<-,list-method}

\title{ The vertex list }
\description{
  Return a list of vertices of classes containing the class \code{VertexProto}.
}
\usage{
returnVertexList(names, labels = NULL, types = NULL, 
                 strata = NULL, line = FALSE, N = 3, 
                 colors = ifelse(types == "TextVertex", 
                                 "FloralWhite", "DarkRed"), 
                 vertexClasses = validVertexClasses())
}
\arguments{
  \item{names}{ Vector of text strings with the \code{names} of the vertices. }
  \item{labels}{ Vector of text strings with the \code{labels} of the vertices. }
  \item{types}{ Vector of text strings with the \code{types} of the vertices. }
  \item{strata}{ Vector of integers with the \code{strata} of the vertices. }
  \item{line}{ Logical, if TRUE then the vertices are positioned on a
               \code{line}, else in a regular polygone, in a circle. }
  \item{N}{ Integer, \code{N} is the number of coordinates of the vertices. }
  \item{colors}{ Vector of text strings with \code{colors} of the vertices. }
  \item{vertexClasses}{ The valid \code{\link{vertexClasses}}. }
}
% \details{ }
\value{
 A list of vertices of classes containing the class \code{VertexProto}.
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{The methods
      \code{\link{Names}}, 
      \code{\link{Names<-}}, 
      \code{\link{Colors}}, 
      \code{\link{Colors<-}}, 
      \code{\link{Labels}}, 
      \code{\link{Labels<-}}, 
      \code{\link{LabelPositions}}, 
      \code{\link{LabelPositions<-}}, 
      \code{\link{Positions}}, 
      \code{\link{Positions<-}}, 
      \code{\link{Strata}}, 
      \code{\link{Strata<-}} and 
      \code{\link{Indices}} 
      are available for vertex lists.
      % \code{\link{Indices<-}}, 
      % \code{\link{Visible}}, 
      % \code{\link{Visible<-}}, 
}
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
vertices <- returnVertexList(c("A", "B", "C", "D"),
                             labels = c("OrdinalVertex", "TextVertex", 
                               "ContinuousVertex", "DiscreteVertex"), 
                             types = c("Ordinal", "TextVertex",
                                       "Continuous", "Discrete"), N = 2)
Names(vertices)
Colors(vertices)
Labels(vertices)
LabelPositions(vertices)
Positions(vertices)
Strata(vertices)
Indices(vertices)
Names(vertices) <- c("a", "b", "c", "d")
Colors(vertices) <- rep("Blue", 4)
Labels(vertices) <- c("A", "B", "C", "D")
LabelPositions(vertices) <- matrix(rep(0, 12), ncol = 3)
Positions(vertices) <- matrix(rep(0, 12), ncol = 3)
Strata(vertices) <- rep(1, 4)
Names(vertices)
Colors(vertices)
Labels(vertices)
LabelPositions(vertices)
Positions(vertices)
Strata(vertices)
Indices(vertices)
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\alias{setBlocks}
\alias{blockList}
\name{setBlocks}
\title{The block list}
\description{
    Create a block list with positioning the vertices in the blocks.    
}
\usage{
setBlocks(block.list, vertices, labels = NULL, 
          right.to.left = FALSE, nested.blocks = FALSE,
          % draw.blocks = TRUE,
          blockColors = NULL, color = "Grey", N = 3)
}
\arguments{
  \item{block.list}{ The list of vectors identifying the \code{blocks}.
          Each item in the list is a vector with of the indices (or text
	  strings for names) of vertices of a block. 
      }
  \item{vertices}{ The list of \code{vertices}, each
      containing the class \code{VertexProto}. Returned with positions
      set in the interval of the blocks. }
  \item{labels}{ List of text strings with the \code{labels} of the
      blocks. If \code{labels} is set to \code{NULL} then labels are
      found as \code{names(block.list)}.
  }
  \item{right.to.left}{ Logical. If \code{right.to.left} is set to TRUE
        then the explanatory blocks are drawn to the right.
        }
  \item{nested.blocks}{ Logical. If \code{nested.blocks} then the
        blocks are drawn nested. }
  % \item{draw.blocks}{ ~~Describe \code{draw.blocks} here~~ }
  \item{blockColors}{ Vector of text string with the \code{blockColors}
        of the blocks. }
  \item{color}{ Single text string with \code{color} of the blocks.
    Only used when \code{blockColors} is not given. }
  \item{N}{ Integer, \code{N} is the number of coordinates of the
      vertices and block corners. }
}
% \details{ ... }
\value{
  A list with components
  \item{Blocks}{The list of blocks, each of class 
        \code{\link{BlockProto}}.}
  \item{Vertices}{The list of vertices,
        with the positions updated such the vertices
        has positions within the blocks. }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{

require(tcltk)

require(dynamicGraph)

V.Types <- c("Discrete", "Ordinal", "Discrete",
             "Continuous", "Discrete", "Continuous")

V.Names <- c("Sex", "Age", "Eye", "FEV", "Hair", "Shosize")
V.Names <- paste(V.Names, 1:6, sep ="/")

From <- c(1, 2, 3, 4, 5, 6)
To   <- c(2, 3, 4, 5, 6, 1)

# A block recursive model:

Blocks <- list(Basic = c(2, 1), Intermediate = c(5, 4, 3),  Now = c(6))

V.Names <- paste(V.Names, c(1, 1, 2, 2, 2, 3), sep =":")

Z <- DynamicGraph(V.Names, V.Types, From, To, blocks = Blocks,
                  width = 600, height = 600, drawblocks = TRUE,
                  drawBlockBackground = FALSE, title = "DrawBlocks")

# A block recursiv model, without drawing blocks:

Z <- DynamicGraph(V.Names, V.Types, From, To, blocks = Blocks,
                  width = 600, height = 600, 
                  drawblocks = FALSE, title = "No blocks drawn")

# A block recursive model with nested blocks:

Z <- DynamicGraph(V.Names, V.Types, From, To, blocks = Blocks,
                  width = 600, height = 600, drawblocks = TRUE, 
                  nested.blocks = TRUE, title = "Nested blocks",
                  blockColors = paste("Grey", 100 - 2 * (1:10), sep = ""))

# The block list of the last example:

vertices <- returnVertexList(V.Names, types = V.Types)
blockList <- setBlocks(Blocks, vertices = vertices,  nested.blocks = TRUE,
                       blockColors = paste("Grey", 100 - 2 * (1:10), sep = ""))

names(blockList)
str(blockList$Blocks[[1]])

names(blockList$Blocks)
Names(blockList$Blocks)
Labels(blockList$Blocks)
LabelPositions(blockList$Blocks)
Positions(blockList$Blocks)
Strata(blockList$Blocks)
Colors(blockList$Blocks)
NodeAncestors(blockList$Blocks)
NodeDescendants(blockList$Blocks)
Visible(blockList$Blocks)
Indices(blockList$Blocks)

names(blockList$Vertices)
Names(blockList$Vertices)
Labels(blockList$Vertices)
LabelPositions(blockList$Vertices)
Positions(blockList$Vertices)
Strata(blockList$Vertices)
Colors(blockList$Vertices)
Indices(blockList$Vertices)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{setTreeBlocks}
\alias{setTreeBlocks}
\alias{Closed}
\alias{Closed<-}
\alias{NodeAncestors}
\alias{NodeAncestors<-}
\alias{NodeDescendants}
\alias{NodeDescendants<-}

\alias{Closed,list-method}
\alias{Closed<-,list-method}
\alias{NodeAncestors,list-method}
\alias{NodeAncestors<-,list-method}
\alias{NodeDescendants,list-method}
\alias{NodeDescendants<-,list-method}

\title{The block tree}
\description{
    Create a block tree with positioning the vertices in to blocks.
}
\usage{
setTreeBlocks(block.tree, vertices, root.label = "", N = 3,
              delta = ifelse(overlaying, 1, 0), Delta = ifelse(overlaying, 0, 1.5),
              d = 5, f = 1/4, blockColors = NULL, overlaying = FALSE)
}

%  \itemize{
     % \item{...$Vertices}{ ~~Describe \code{Vertices} here~~ }
     % \item{...$label}{ ~~Describe \code{label} here~~ }
     % \item{...$d}{ ~~Describe \code{d} here~~ }
     % \item{...$g}{ ~~Describe \code{g} here~~ }
     % \item{...$f}{ ~~Describe \code{f} here~~ }
     % \item{...$G}{ ~~Describe \code{G} here~~ }
     % \item{...$F}{ ~~Describe \code{F} here~~ }
     % \item{...$horizontal}{ ~~Describe \code{horizontal} here~~ }
     % \item{...$vertices.last}{ ~~Describe \code{vertices.last} here~~ }
     % \item{...$"block-name" = list(...) }{
     %                ~~Describe \code{"block-name" = list(...)} here~~ }
     % \item{...$common.children}{ ~~Describe \code{common.children}
     %                              here~~ }
%          }

\arguments{
  \item{block.tree}{ A structure with the blocks in a \code{block.tree}.
	See below. }
  \item{vertices}{ The list of \code{vertices}, each
      containing the class \code{VertexProto}. Returned with positions
      set in the interval of the blocks. }
  \item{root.label}{ A text string with the \code{root.label}
      of the root block. }
  \item{N}{ Integer, \code{N} is the number of coordinates of the
      vertices and block corners. }
  \item{delta}{ Numeric. Decrement of block size for nested blocks,
	        and space between blocks when \code{overlaying} is TRUE.
                The decrement is  \code{delta} divided by 100, times
                the the size of the window canvas, width or height. } 
  \item{Delta}{ Numeric. Decrement of block size for nested blocks,
	        and space between blocks when \code{overlaying} is FALSE. 
                The decrement is \code{Delta} divided by 100, times
                the the size of the window canvas, width or height. }
  \item{d}{ Numeric. If not \code{d} is given in \code{block.tree}, see below:
            The heading bar (with the label) has a height of
            (\code{d} + 2) divided by 100,
            times height of the window canvas. }
  \item{f}{ Numeric. If not \code{f} or \code{g} is given in \code{block.tree},
            see below:
            The the vertices of the block are placed in an array with a height
            (width if \code{horizontal} is set to FALSE)
            of \code{f} divided by 100,
            times height (width) of the block. 
            Thus this size is relative to the block size. }
  \item{blockColors}{ Vector of text string with the \code{blockColors}
        of the blocks. }
  \item{overlaying}{ Logical. If \code{overlaying} is set to FALSE
        then children blocks of a block are not drawn inside the block. }
}
\details{ 

  A recursive definition:
  \code{Block.tree} is a list with the vertices of the "current" blocks,
  some parameters for controlling the layout,
  and possible some \code{block.trees}:

  \itemize{
      \item{\code{...\$Vertices}}{ The \code{vertices} of the block. }
      \item{\code{...\$label}}{ A text string for
            the \code{label} of the block. 
	    Will overwrite \code{"block-name"} and  \code{root.label}. }
      \item{\code{...\$d}}{ Numeric.
            The heading bar (with the label) has a height of
            (\code{d} + 2) divided by 100,
            times the height of the window canvas. }
      \item{\code{...\$g}}{ Numeric.
            The vertices of the block are placed in an array with a height 
            (width if \code{horizontal} is set to FALSE)
            of \code{g} divided by 100,
            times the height (width) of the window canvas. 
            Thus this size will not decrease with the block size.
            }
      \item{\code{...\$f}}{ Numeric.
            If not \code{g} is given:
            The the vertices of the block are placed in an array with a height
            (width if \code{horizontal} is set to FALSE)
            of \code{f} divided by 100,
            times the height (width) of the block. 
            Thus this size is relative to the block size. }
      \item{\code{...\$G}}{ Numeric.
            (If the height of the block is 100 we are now left with 
             \code{100 - 2 * delta - d - 2 - g} for the blocks. )
            The sub blocks (apart from \code{common.children})
            then have a of height 
            (width, if \code{horizontal} is set to FALSE)
            of \code{G} divided by 100,
            times the height (width) of the window canvas. 
            Thus the sub block size will not decrease with the block size.
            (If the height of the block is 100 we are now left with 
             \code{100 - 2 * delta - d - 2 - g - G}
             for the \code{common.children}. )
            }
      \item{\code{...\$F}}{ Numeric.
            If not \code{G} is given:
            The proportion \code{G} of the remaining space 
            are used for sub blocks (apart from \code{common.children})
            and the proportion \code{G} of the space for blocks
            are used for \code{common.children}.
            }
      \item{\code{...\$horizontal}}{ Logical.
            If \code{horizontal} is set to TRUE,
            then the sub blocks, but \code{common.children},
            are placed side by side,
	    else the blocks are placed vertically. }
      \item{\code{...\$closed}}{ Logical.
            If \code{closed} is set to TRUE,
            then the block is initially drawn "closed",
            and the vertices and sub blocks of the block are not visible. }
      \item{\code{...\$vertices.last}}{  Logical. If \code{vertices.last} then
	    the vertices of the block are placed after the sub blocks. }
      \item{\code{...\$"block-name"}}{\code{= list(...)}
                    Repeated zero, one or more times for sub blocks.
                    \code{"block-name"} is the label of the block,
                    and \code{list(...)} is a \code{Block.tree}. }
      \item{\code{...\$common.children}}{\code{= list(...)}
                    Omitted, or a list with common children
                    of the other sub blocks of the block. 
                    The list is again a \code{Block.tree}. }
  }
}
\value{
  A list with components
  \item{BlockTree}{A tree of blocks, each of class \code{\link{BlockProto}}. }
  \item{Vertices}{The list of vertices,
        with the positions updated such the vertices
        has positions within the blocks. }
}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
\note{ 

      Ancestors and descendants are set in \code{\link{setTreeBlocks}}.
      Ancestors are used in the function \code{\link{returnBlockEdgeList}} to
      find the edges between blocks and between blocks and vertices.
      Descendants are used in \code{\link{dynamicGraphMain}}
      when closing, opening and moving blocks,
      and when adding or dropping edges from and to blocks.
      The methods \code{\link{NodeAncestors}}, \code{\link{NodeAncestors<-}}
      \code{\link{NodeDescendants}} and \code{\link{NodeDescendants<-}}
      can be used on the block list resulting of 
      \code{\link{blockTreeToList}} on the block tree.

}
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{
# Example 1:

Block.tree <- list(label = "W", Vertices = c("country"),
                   X = list(Vertices = c("race", "sex"),
                            A = list(Vertices = c("hair", "eye"),
                                     horizontal = FALSE),
                            B = list(Vertices = c("education"),
                                     C = list(Vertices = c("age")))))
V.Names <- unlist(Block.tree)
vertices <- returnVertexList(V.Names[grep("Vertices", names(V.Names))])
blocktree <- setTreeBlocks(Block.tree, vertices)

Positions(blockTreeToList(blocktree$BlockTree))
Positions(blocktree$Vertices)
NodeAncestors(blockTreeToList(blocktree$BlockTree))
NodeDescendants(blockTreeToList(blocktree$BlockTree))

vertexStrata <- Strata(blocktree$Vertices)
vertexStrata
vertexNames <- Names(blocktree$Vertices)
names(vertexNames) <- NULL
vertexNames

# Indices of the vertices in blocks:

indicesInBlock <- vector("list", max(vertexStrata))
for (i in seq(along = vertexStrata))
  indicesInBlock[[vertexStrata[i]]] <- 
    append(indicesInBlock[[vertexStrata[i]]], i) 
str(indicesInBlock)

# Names of the vertices in blocks:

vertexNamesInblock <- vector("list", max(vertexStrata))
for (i in seq(along = vertexStrata))
  vertexNamesInblock[[vertexStrata[i]]] <- 
    append(vertexNamesInblock[[vertexStrata[i]]], vertexNames[i]) 
str(vertexNamesInblock)

# A useful function, replace "k" (block index k) 
# in block "i" by "x[k]", the content "x[k]" of block "k":

f <- function(A, x) {
  result <- vector("list", length(A))
  names(result) <- names(A)
  for (i in seq(along = A))
    if ((length(A[[i]]) > 0) && (A[[i]] != 0))
      for (k in A[[i]])
        result[[i]] <- append(result[[i]], x[k])
  return(result)
}

# For each block, names of vertices in ancestor blocks:

vertexAncOfBlock <- f(NodeAncestors(blockTreeToList(blocktree$BlockTree)), 
                      vertexNamesInblock)
str(vertexAncOfBlock)

for (i in seq(along = vertexAncOfBlock))
  if (length(vertexAncOfBlock[[i]]) > 0)
    vertexAncOfBlock[[i]] <- unlist(vertexAncOfBlock[[i]])
str(vertexAncOfBlock)

# For each block, names of vertices in descendant blocks:

vertexDesOfBlock <- f(NodeDescendants(blockTreeToList(blocktree$BlockTree)),
                      vertexNamesInblock)
str(vertexDesOfBlock)

for (i in seq(along = vertexDesOfBlock))
  if (length(vertexDesOfBlock[[i]]) > 0)
    vertexDesOfBlock[[i]] <- unlist(vertexDesOfBlock[[i]])
str(vertexDesOfBlock)


# Example 2:

Block.tree <-
  list(g = 0, G = 54, label = "Pedegree.G",
       Male.Side = 
       list(g = 0, G = 33,
            Father = 
            list(g = 0, G = 12,
                 P.G.Father = list(Vertices = c("P.G.Father.1")),
                 P.G.Mother = list(Vertices = c("P.G.Mother.1")),
                 common.children = list(g = 0, label = "Father.1",
                                        Vertices = c("Father.1"))),
            Mother = 
            list(g = 0, G = 12,
                 M.G.Father = list(Vertices = c("M.G.Father.1")),
                 M.G.Mother = list(Vertices = c("M.G.Mother.1")),
                 common.children = list(g = 0, label = "Mother.1",
                                        Vertices = c("Mother.1"))),
            common.children = list(g = 2, Vertices = c("Male"))),
  Female.Side = list(g = 0, G = 12,
    P.G.Father = list(Vertices = c("P.G.Father.2")),
    P.G.Mother = list(Vertices = c("P.G.Mother.2")),
    M.G.Father = list(Vertices = c("M.G.Father.2")),
    M.G.Mother = list(Vertices = c("M.G.Mother.2")),
    common.children = list(g = 0, G = 12, label = "Female",
      Father = list(Vertices = c("Father.2")),
      Mother = list(Vertices = c("Mother.2")),
      common.children = list(g = 2, Vertices = c("Female")))),
  common.children = list(Vertices = c("Marriage"), g = 3, label = "Children",
    Son = list(Vertices = c("Son"), g = 3, 
       P.G.Son = list(Vertices = c("P.G.Son"), g = 2),
       P.G.Dat = list(Vertices = c("P.G.Dat"), g = 1)),
    Dat = list(Vertices = c("Dat"), g = 2,
       M.G.Son = list(Vertices = c("M.G.Son")),
       M.G.Dat = list(Vertices = c("M.G.Dat")))
    )
)

v <- unlist(Block.tree)
V.Names <- v[grep("Vertices", names(v))]
rm(v)

FromTo <- matrix(c("P.G.Father.1", "Father.1", "P.G.Father.2", "Father.2", 
                   "P.G.Mother.1", "Father.1", "P.G.Mother.2", "Father.2", 
                   "M.G.Father.1", "Mother.1", "M.G.Father.2", "Mother.2", 
                   "M.G.Mother.1", "Mother.1", "M.G.Mother.2", "Mother.2", 
                   "Father.1",     "Male",     "Father.2",     "Female",   
                   "Mother.1",     "Male",     "Mother.2",     "Female",   
                   "Male",         "Marriage", "Female",       "Marriage",
                   "Marriage",     "Son",      "Marriage",     "Dat",
                   "Son",          "P.G.Son",  "Dat",          "M.G.Son", 
                   "Son",          "P.G.Dat",  "Dat",          "M.G.Dat"), 
                   byrow = TRUE, ncol = 2)

From <- match(FromTo[,1], V.Names)
To   <- match(FromTo[,2], V.Names)

V.Types <- rep("Discrete", length(V.Names))

Z <- DynamicGraph(V.Names, V.Types, From, To, block.tree = Block.tree, 
                  object = Object, width = 600, height = 600, 
                  drawblocks = TRUE, drawBlockFrame = TRUE, 
                  overlaying = TRUE, title = "Pedegree.G")

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{validFactorClasses}
\alias{factorClasses}
\alias{validFactorClasses}
\title{Valid factor vertex classes}
\description{Return matrix with labels of valid factor vertex classes
and the valid factor vertex classes. }
\usage{validFactorClasses()}
\details{The argument \code{factorClasses} to \code{\link{DynamicGraph}},
 and to \code{\link{returnFactorVerticesAndEdges}} and \code{\link{newFactor}}
 is by default the returned value of this function.
 If new factor vertex classes are created then \code{factorClasses}
 should be set to a value with this returned value extended appropriate. }
\value{Matrix of text strings with labels (used in dialog windows)
       of valid factor vertex classes and the valid factor 
       vertex classes (used to create the factor vertices).}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
\seealso{\code{\link{validVertexClasses}}}
\examples{
validFactorClasses()
}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
\name{validVertexClasses}
\alias{vertexClasses}
\alias{validVertexClasses}
\title{Valid vertex classes}
\description{Return matrix with labels of valid vertex classes
and the valid vertex classes}
\usage{validVertexClasses()}
\details{The argument \code{vertexClasses} to
    \code{\link{dynamicGraphMain}} and
    \code{\link{DynamicGraph}}, and to
    \code{\link{newVertex}} and
    \code{\link{returnVertexList}}
    is by default the returned value of this
    function. If new vertex classes are created then \code{vertexClasses}
    should be set to a value with this returned value extended appropriate. }
\value{Matrix of text strings with labels (used in dialog windows)
       of valid vertex classes
       and the valid vertex classes (used to create the vertices).}
% \references{ ~put references to the literature/web site here ~ }
\author{Jens Henrik Badsberg}
% \note{ ~~further notes~~ }
% \seealso{ ~~objects to See Also as \code{\link{dynamicGraphMain}}, ~~~ }
\examples{

require(tcltk)

# library(dynamicGraph)

setClass("NewVertexProto", contains = "VertexProto")

myVertexClasses <- rbind(validVertexClasses(), 
                         NewVertex = c("NewVertex", "NewVertexProto"))

setMethod("draw", "NewVertexProto",
          function(object, canvas, position,
                   x = position[1], y = position[2], stratum = 0,
                   w = 2, color = "green", background = "white") {
            s <- w * sqrt(4 / pi) / 2
            p1 <- tkcreate(canvas, "oval", x - s - s, y - s,
                           x + s - s, y + s, fill = color(object))
            p2 <- tkcreate(canvas, "oval", x - s + s, y - s,
                           x + s + s, y + s, fill = color(object))
            p3 <- tkcreate(canvas, "oval", x - s, y - s - s,
                           x + s, y + s - s, fill = color(object))
            p4 <- tkcreate(canvas, "poly", x - 1.5 * s, y + 3 * s,
                           x + 1.5 * s, y + 3 * s,  x, y, fill = color(object))
            return(list(dynamic = list(p1, p2, p3, p4), fixed = NULL)) })

setMethod("addToPopups", "NewVertexProto",
          function(object, type, nodePopupMenu, ...) {
               tkadd(nodePopupMenu, "command",
                     label = paste(" --- This is a my new vertex!"),
                     command = function() { print(name(object))})
          })

# Why are these 2 * 7 methods not avaliable from "VertexProto" ?

setMethod("color", "NewVertexProto", function(object) object@color)
setReplaceMethod("color", "NewVertexProto",
                 function(x, value) {x@color <- value; x} )

setMethod("label", "NewVertexProto", function(object) object@label)
setReplaceMethod("label", "NewVertexProto",
                 function(x, value) {x@label <- value; x} )

setMethod("labelPosition", "NewVertexProto",
          function(object) object@label.position)
setReplaceMethod("labelPosition", "NewVertexProto",
                 function(x, value) {x@label.position <- value; x} )

setMethod("name", "NewVertexProto", function(object) object@name)
setReplaceMethod("name", "NewVertexProto",
                 function(x, value) {x@name <- value; x} )

setMethod("index", "NewVertexProto", function(object) object@index)
setReplaceMethod("index", "NewVertexProto",
                 function(x, value) {x@index <- value; x} )

setMethod("position", "NewVertexProto", function(object) object@position)
setReplaceMethod("position", "NewVertexProto",
                 function(x, value) {x@position <- value; x} )

setMethod("stratum", "NewVertexProto", function(object) object@stratum)
setReplaceMethod("stratum", "NewVertexProto",
                 function(x, value) {x@stratum <- value; x} )

V.Types <- rep("NewVertex", 6)

V.Names <- c("Sex", "Age", "Eye", "FEV", "Hair", "Shosize")
V.Names <- paste(V.Names, 1:6, sep ="/")

From <- c(1, 2, 3, 4, 5, 6)
To   <- c(2, 3, 4, 5, 6, 1)

Z <- DynamicGraph(V.Names, V.Types, From, To, edgeColor = "green", 
                  vertexColor = "blue", vertexClasses = myVertexClasses)

}
\keyword{ methods }
\keyword{ dynamic }
\keyword{ graphs }

\eof
